clear all
clc
close all

global nvar nlags ncoint nconst
global para_mask para_fix
global nobs lambda
global Pmean Pstd pshape

restoredefaultpath

currentpath = pwd;
model       = 'BL';
eval(['addpath ', currentpath(1:end-length(model)), 'MODEL'])

datapath    = 'C:\Users\anutako\Dropbox\Research\Government_Spending\data\';

rand('state',sum(100*clock))
varspec();
VECM        = 0 ;
format long g
if (1 == 1)
    [series,YY,XX,ti] = loaddata(datapath);
    if (VECM == 0)
        XX = XX(:,ncoint+1:end);
    end
    YY = YY - kron(mean(YY),ones(length(YY),1));%kron(mean(YY),[1;1])
    XX = XX - kron(mean(XX),ones(length(XX),1));
    YYYY = YY'*YY;
    XXYY = XX'*YY;
    XXXX = XX'*XX;

    pshape = pshape.*(1-para_mask); % either distr or 0
    Pmean  = Pmean.*( 1-para_mask) + para_fix.*para_mask;% either pmean or fixes value
    Pstd   = Pstd.*( 1-para_mask); % either pstdd or zero

    fid = fopen('mXXXX_dm8.txt','w');
    for i = 1:size(XXXX,1)
        for j = 1:size(XXXX,1)
            fprintf(fid,[ num2str(XXXX(j,i),'%10.16f') , '\r\n']);
        end
    end
    fclose(fid);

    fid = fopen('mYYYY_dm9.txt','w');
    for i = 1:nvar
        for j = 1:nvar
            fprintf(fid,[ num2str(YYYY(j,i),'%10.16f') , '\r\n']);
        end
    end
    fclose(fid);

    fid = fopen('mXXYY_dm9.txt','w');
    for i = 1:nvar
        for j = 1:size(XXXX,1)
            fprintf(fid,[ num2str(XXYY(j,i),'%10.16f') , '\r\n']);
        end
    end
    fclose(fid);
end
%return
% load mXXYY_dm0.txt
% load mXXXX_dm0.txt
% load mYYYY_dm0.txt
% 
% XXXX = reshape(mXXXX_dm0,nconst+ncoint+nvar*nlags,nconst+ncoint+nvar*nlags);
% XXYY = reshape(mXXYY_dm0,nconst+ncoint+nvar*nlags,nvar);
% YYYY = reshape(mYYYY_dm0,nvar,nvar);
% clear mXXXX_dm0
% clear mXXYY_dm0
% clear mYYYY_dm0

nobs = 221;%size(YY,1);
lambdas  = 0.4;%33;
lambda = lambdas*nobs;

%load mean_est.txt
%Theta = mean_est';
%Theta = Pmean';
%Theta = [ 0.5D+0,  20.0D+0, 100.0D+0, 0.7D+0, 0.5D+0, 0.1D+0, 1.0D+0,     2.0D+0 , 2.0D+0, 0.85D+0, 0.01D+0, 0.9D+0, 0.5D+0, 0.5D+0, 0.5D+0,  0.5D+0, 0.5D+0, 0.8D+0, 0.8D+0, 0.1D+0, 0.1D+0, 0.1D+0, 0.1D+0, 0.1D+0, 0.1D+0, 0.1D+0, 0.1D+0];

%load C:\Users\anutako\Dropbox\Research\Government_Spending\RR_JMCB\GOVSP_2015_0609_files\GOVSP_2015_0609_files\fortran\results_DSGEVAR\2015_0602\BL\LA04\mean_est.txt
load C:\Users\anutako\Dropbox\Research\GSP3\DSGEVAR\BL\mean_est.txt
%Theta = [         0.6310508                  20.75776                  125.1338                 0.7777589                 0.5545456               0.092313401                 0.3425082                  2.236229                  2.693452                 0.8981535              0.0076068314                 0.9517525                 0.2109822                 0.8872966                 0.2458975                 0.1380388                 0.1761877                  0.782168                 0.7825608               0.010262655             0.0063665011              0.0023544123               0.026035726               0.076237269                  1.469501              0.0015752752               0.019376749];
Theta = mean_est;

[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;
loglike = objfcnmh(Theta,YYYY,XXYY,XXXX,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu)
return
%acc   = 0;
%count = 0;
% hessian = 1;
% if hessian == 1 
%      hessian_x     = fn_hesscd(Theta,1.e-05,YYYY,XXYY,XXXX,f, fx, fy, fxp, fyp, statevar_cu,controlvar_cu);
%      H0            = -inv(hessian_x);
%      [V,D]         = eig(H0);
%      D             = abs(D);
%      H0            = V*D*V';
%      D             = chol(H0);
% else
%       D = 1;
% end
% save hess.mat D 
% return

%load hess.mat D

load res_BL.mat y xDist_BL
format short g
sig_th = 0.03;
tic;
Niter = 30001;

for j = 1:100:Niter
%     if rem(j,10000) == 0  
%        [ j  loglike acc ]
%        Theta
%     end
%     exitflag = 0;
%     while exitflag ~= 1
%         newTheta  = Theta + (sig_th*randn(size(Theta)))*D;
%         newlogpri = priordeephabits(newTheta);
%         while newlogpri == -inf 
%             newTheta  = Theta + (sig_th*randn(size(Theta)))*D;%mvnrnd(zeros(1,length(Theta)), variance_normal); 
%            newlogpri = priordeephabits(newTheta);
%        end
%        %[newloglike, exitflag] = kalman(newTheta,data,f, fx, fy, fxp, fyp,statevar_cu,controlvar_cu,statevar_cup,controlvar_cup);
%         newloglike = objfcnmh(newTheta,YYYY,XXYY,XXXX,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);
%    end
     
    newloglike(j) = objfcnmh(y(j,:),YYYY,XXYY,XXXX,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);
    [ j newloglike(j) xDist_BL(j) ]
%     if newloglike == -Inf;
%                 ratio = 0;
%         else
%                 ratio = exp(newloglike + newlogpri - (loglike + logpri));
%                 count = count + 1;
%                 if rand <= ratio % we accept with prob ratio
%                         loglike = newloglike;
%                         logpri  = newlogpri;
%                         Theta   = newTheta;
%                         acc     = acc + 1; % keeping track of the acceptances
%                 end
%         end
%         Theta_s(j,:)   = Theta;
%         loglike_s(j,1) = loglike;
%         logpri_s(j,1)  = logpri;
end
return
Theta           = mean(Theta_s,1);
acceptance_rate = acc/Niter*100;

toc
hours=toc/3600