function logprior = prior(Theta, Up, Lo, a, b, index_U, index_N, index_B, index_G , index_IG)

index_U  = index_U(:);
index_N  = index_N(:); 
index_B  = index_B(:);
index_G  = index_G(:);
index_IG = index_IG(:);
Lo = Lo(:);
Up = Up(:);

if ( sum([ index_U;index_N;index_B;index_G;index_IG] ) ~= 0.0 )
    a = a(:)';
    b = b(:)';
    p = 0;
    for i = 1:length(Theta)
        p = 0;
        % UNIFORM DISTRIBUTIONS
        %disp('u')
        %p  = sum( log( 1./(b(index_U) - a(index_U)) ) ) + p;
        % BETA DISTRIBUTIONS
        if ( index_B ~= 0 )
            %disp('b')
            xn = (Theta(i,index_B)- Lo(index_B)')./(Up(index_B) - Lo(index_B))';
            p  = sum( log( xn.^ (a(index_B) - 1).*(1 - xn).^(b(index_B) - 1)./ beta(a(index_B),b(index_B)) ) ) + p;
            %[index_B, Theta(i, index_B)' a(index_B)', b(index_B)']
            % checkbeta = Theta(i,index_B).^ (a(index_B) - 1).*(1 - Theta(i,index_B)).^(b(index_B) - 1)  
        end
        %'B'
        %p
%        [ xn ;        ( xn.^ (a(index_B) - 1).*(1 - xn).^(b(index_B) - 1)./ beta(a(index_B),b(index_B)) )]
        if ( index_N ~= 0 )
            % NORMAL DISTRIBUTIONS
            % p = log(normpdf(Theta(i), 1, 1))+p; %investment adjustment cost
            xn = (Theta(i,index_N)-a(index_N))./b(index_N);
            %disp('n')
            p  = sum( -0.5*xn.^2 - 0.5*log(2*pi) - log(b(index_N) )) + p;
            %[index_N, Theta(i, index_N)' a(index_N)' b(index_N)']
        end
        if ( index_G ~= 0 )
            % GAMA DISTRIBUTIONS
            %disp('g')
            p = sum((a(index_G) - 1).*log(Theta(i,index_G)) - (Theta(i,index_G) ./ b(index_G)) - gammaln(a(index_G)) - a(index_G).*log(b(index_G)) )+ p;
            %[index_G, Theta(i, index_G)'  a(index_G)' b(index_G)']
        end
        %'G'
        %p
        %[Theta(i,index_G); (a(index_G) - 1).*log(Theta(i,index_G)) - (Theta(i,index_G) ./ b(index_G)) - gammaln(a(index_G)) - a(index_G).*log(b(index_G)) ]
        if ( index_IG ~= 0 )
            % INV GAMA DISTRIBUTIONS
            %disp('ig')
            p = sum(log(  b(index_IG).^a(index_IG)./gamma(a(index_IG)).*Theta(i,index_IG).^(-a(index_IG)-1)...
                .*exp(-b(index_IG)./Theta(i,index_IG)) )) + p;
            %[index_IG, Theta(i, index_IG)' a(index_IG)' b(index_IG)']
        end
        %'IG'
        %p
        logprior(i,1) = p;
    end
else
    logprior = 0;    
end