%function [RHOupsP, RHOupsW, UPSP, UPSW, MUw, MUp,  QQ, EPSG, EPSP, EPSW, RHOp, RHOw, TAU, EPSTAU, RHOtau, ALFA_tau, ALFA_tauy, ZZETA, PHI, LA, RHOPREF, RHOG, RHOMUZ, RHOMUUPS, RHOR, PSSI, BETTA, THETA, DELTA, HB, KAPA, GAMAI, GAMAII, ETA, ETATIL, ALFA, ALFATIL, ALFA_R, ALFA_PAI, ALFA_Y, SSIGMA, R, D, G, MUZ, MUUPS, H, K, OUTPUT, C, PAI, U, MUTIL, W, IV, MUZSTAR, MC, MUR] = steady_state(x);

TAU      = 0.18;
RHOtau   = 0;

RHOupsP  = 0;
RHOupsW  = 0;
UPSP     = 1;
UPSW     = 1;
EPSTAU   = 1;
EPSP     = 1;
EPSW     = 1;
%EPSG     = 0.2;

QQ       = 1;
MUR      = 1;
ETA      = 6;
ETATIL   = 21;

U        = 1;
PAI      = 1.0086;%1.042^(1/4); %Inflation
BETTA    = 0.999;
THETA    = 0.3;%0.36; %Capital share; I use a much smaller capital share to avoid the problem of getting an investment share of over 1/3 of GDP.
DELTA    = 0.025; 
MUZSTAR  = 1.0047; % steady state growth rate of output is 0.0047
MUUPS    = 1.0042; % ACEL
D        = 1;
RHOR     = 0;
SHAREG   = 0.2; % Share of gov't expenditures in gdp 
EPSG     = SHAREG*MUZSTAR;

PHI          = 0.8;%x(4);%0.8; % Share of private consumption in effective consumption
HB           = x(1);% 0.7;
ALFA         = x(2);% 20
ALFATIL      = x(3);% 20
ALFA_R       = x(4);%0.5;
ALFA_PAI     = x(5);%1;
ALFA_Y       = x(6);%0.2;
KAPA         = x(7);%3;
GAMAII_GAMAI = x(8);%2;% FIX IT   %0.01;
SSIGMA       = x(9);
ALFA_tau     = x(10);
ALFA_tauy    = x(11);

RHOG     = x(12);% 0.5;
RHOMUZ   = x(13);% 0.5;
RHOMUUPS = x(14);% 0.5;
RHOPREF  = x(15);% 0.5;
RHOp     = x(16);
RHOw     = x(17);
MUp      = x(18);
MUw      = x(19);

MUZ      = MUZSTAR/ MUUPS^(THETA/(1-THETA));
MUI      = MUUPS * MUZSTAR; 
R        = PAI / BETTA *MUZSTAR; %Nominal interest rate
RK       = (MUI/BETTA -QQ*(1 - DELTA))/(1-TAU);
MUTIL    = ETATIL / (ETATIL-1)/(1-TAU);
MC       = (ETA - 1)/ETA;% Marginal cost of producing a unit of final good

K_H      = MUI/U*(RK/MC/THETA)^(1/(THETA-1)); % Aggregate capital factor input
IV_H     = (1-(1-DELTA)/MUI) * K_H; % investment
W        = MC * (1-THETA) * (U*K_H/MUI)^THETA; % Average real wage rate
OUTPUT_H = MC*(U*K_H/MUI)^THETA ; % Aggregate absorption
PSSI_H   = (1-MC)*(U*K_H/MUI)^THETA;
G_H      = SHAREG * OUTPUT_H;  % Government spending
C_H      = OUTPUT_H - IV_H - G_H ; % Private consumption

% K_OUTPUT  = THETA*MUI/U/RK;
% I_OUTPUT  = (1-(1-DELTA)/MUI) * K_OUTPUT;
% C_OUTPUT  = 1-SHAREG-I_OUTPUT;
%XX_OUTPUT = C_OUTPUT*(1- HB/MUZSTAR);
%H         = ((1-THETA)*(1-HB*BETTA/MUZSTAR)/MUTIL/ XX_OUTPUT )^(1/(1+ZZETA));
%H         = ((1-THETA)*(1-HB*BETTA/MUZSTAR)/MUTIL )^(1/(ZZETA));
%1/H = 1 + MUTIL/W*C_H*(1 - HB/MUZSTAR)/(1-HB*BETTA/MUZSTAR)*(ZZETA + 1)/(1 - SSIGMA)
%H = 1/(MUTIL/W*C_H*(1 - HB/MUZSTAR)/(1-HB*BETTA/MUZSTAR)*(ZZETA + 1)/( 1-SSIGMA ));
%1 = MUTIL/W*C_H*(1 - HB/MUZSTAR)*(ZZETA + 1)/(1-SSIGMA)/(1-HB*BETTA/MUZSTAR)
H = 0.5;
%ZZETA = 1- W/MUTIL/C_H/(1 - HB/MUZSTAR)*(1-HB*BETTA/MUZSTAR)*(1-SSIGMA);
%LA = D*( C*(1-HB/MUZSTAR))^(-SSIGMA)*(1 - H)^(ZZETA+1)*(1-HB*BETTA/MUZSTAR);
%LA*W + (D*MUTIL*(C - (C*HB)/MUZSTAR)^(1 - SSIGMA)*(1 - H)^ZZETA*(ZZETA + 1))/(SSIGMA - 1)
%LA*W - (D*H^ZZETA*MUTIL*(C - (C*HB)/MUZSTAR)^(1 - SSIGMA)*(ZZETA + 1))/(SSIGMA - 1)

OUTPUT = OUTPUT_H *H;
%OUTPUT    = (MC*(K_OUTPUT*U/H/MUI)^THETA*H)^(1/(1-THETA));
K  = K_H*H;
IV = IV_H*H;
C  = C_H*H;
G  = G_H*H;

% K    = K_OUTPUT*OUTPUT;
% IV   = I_OUTPUT*OUTPUT;
% C    = C_OUTPUT*OUTPUT;
% G    = SHAREG*OUTPUT;
% W    = (1-THETA)*OUTPUT/H;
%XX   = XX_OUTPUT*OUTPUT;

%LA       = D * ( C*(1-HB/MUZSTAR)*(1 - H^(ZZETA+1)/(ZZETA+1)))^(-SSIGMA)*(1-HB*BETTA/MUZSTAR); %!!!!
%LA = D*( C*(1-HB/MUZSTAR))^(-SSIGMA)*H^(ZZETA+1)*(1-HB*BETTA/MUZSTAR);

%(1 - BETTA*HB/MUZSTAR)*W/MUTIL = ZZETA/(1-SSIGMA) * (C - (C*HB)/MUZSTAR)/(1 - H)
ZZETA = (1-SSIGMA)*(1-H)/(C - (C*HB)/MUZSTAR)*(1 - BETTA*HB/MUZSTAR)*(1-TAU)*W/MUTIL;
LA = D*(1 - H)^ZZETA/(C - (C*HB)/MUZSTAR)^SSIGMA* (1 - BETTA*HB/MUZSTAR);

% ZZETA = - 1 + H*(1-HB*BETTA/MUZSTAR)*W/MUTIL*(SSIGMA-1)/C/(1- HB/MUZSTAR);
% LA       = D * ( C*(1-HB/MUZSTAR))^(-SSIGMA) * H^(ZZETA+1)*(1-HB*BETTA/MUZSTAR); %!!!!

PSSI     = (1-MC)*(U*K/MUI)^THETA* H^(1-THETA);

GAMAI  = (1-TAU)*RK/QQ;
GAMAII = GAMAII_GAMAI*GAMAI;
BETTA  = BETTA/MUZSTAR^(1-SSIGMA);
%EPSG = G;

MUC  = MUZSTAR; 
MUIV = MUI;
MUW  = MUZSTAR; 