%function [yyyyd,xxyyd,xxxxd,retcode] = varprio(TTT,RRR,valid,para,nvar,nlags,mspec,npara,coint,cointadd,cointall);
function [yyyyd,xxyyd,xxxxd, ZZ] = varprio_dn(x,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);

global nvar nlags ncoint
steady_state();
[ gx, hx, exitflag ] = deep_run(x, f, fx, fy, fxp, fyp, statevar_cu, controlvar_cu);

nstate   = length(statevar_cu);
ncontrol = length(controlvar_cu);

STD_EPSG     = x(end-7);
STD_EPSMUZ   = x(end-6);
STD_EPSMUUPS = x(end-5);
STD_EPSD     = x(end-4);
STD_EPSP     = x(end-3);
STD_EPSW     = x(end-2);
STD_EPSR     = x(end-1);
STD_EPStau   = x(end);

smuz   = find( statevar_cu == 'muz_ba1'    );
smuups = find( statevar_cu == 'muups_ba1'  );
sd     = find( statevar_cu == 'd_ba1'      );
sg     = find( statevar_cu == 'epsg_ba1'   );
sr     = find( statevar_cu == 'mur_ba1'    );
stau   = find( statevar_cu == 'epstau_ba1' );
sp     = find( statevar_cu == 'upsp_ba1'   );
sw     = find( statevar_cu == 'upsw_ba1'   );
%ng     = find([controlvar_cu] == 'epsg_ba1' );
ng     = find([controlvar_cu] == 'g_cu' );
nr     = find(controlvar_cu == 'r_cu'     );
ni     = find(controlvar_cu == 'iv_cu'    );
nc     = find(controlvar_cu == 'c_cu'     );
npi    = find(controlvar_cu == 'pai_cu'   );
nw     = find(controlvar_cu == 'w_cu'     );
nh     = find(controlvar_cu == 'h_cu'     );
noutput= find(controlvar_cu == 'output_cu');
ntau   = find(controlvar_cu == 'tau_cu'   );

ZZ(1,:) = gx(noutput,:);%-gx(noutput,:); %*(hx - eye(size(hx)))+ hx(smuz,:) + 0.3/(1-0.3)*hx(smuups,:);
ZZ(2,:) = gx(ntau,:);
ZZ(3,:) = gx(ni,:);%*(hx - eye(size(hx)))+ hx(smuz,:) +   1  /(1-THETA)*hx(smuups,:);
ZZ(4,:) = gx(nc,:);%*(hx - eye(size(hx)))+ hx(smuz,:) + THETA/(1-THETA)*hx(smuups,:);
ZZ(5,:) = gx(nw,:);%*(hx - eye(size(hx)))+ hx(smuz,:) + THETA/(1-THETA)*hx(smuups,:);
ZZ(6,:) = gx(nh,:);
ZZ(7,:) = 4*gx(npi,:);
ZZ(8,:) = 4*gx(nr,:);
EZZ = [log(OUTPUT); log(TAU); log(IV); log(C); log(W) ;log(H); 4*log(PAI) ;4*log(R) ];
EZZZZ = EZZ*EZZ';

% St = statevars, endogenous states and exogenous states
TTT = hx;

RRR = zeros(nstate,nvar);
RRR(sg,1)     = STD_EPSG;  
RRR(smuz,2)   = STD_EPSMUZ;
RRR(smuups,3) = STD_EPSMUUPS;
RRR(sd,4)     = STD_EPSD;
RRR(sp,5)     = STD_EPSP;
RRR(sw,6)     = STD_EPSW;
RRR(sr,7)     = STD_EPSR;
RRR(stau,8)   = STD_EPStau;

QQ = RRR*RRR';
GA0 = mom_state(hx,QQ,0);

if exitflag ~= 1 
   yyyyd = 0; xxyyd = 0; xxxxd = 0; retcode = 0;
   return
end

%HH = EE + MM*QQ*MM';
%VV = QQ*MM';

% Compute nlags autocovariances
% Initialize Autocovariances

GAMM0 = zeros((nvar+ncoint)^2,nlags+1);
%GA0 = dlyap(TTT,RRR*QQ*RRR');
%GA0 = dlyap(TTT,QQ);
Gl   = ZZ*GA0*ZZ'; % + ZZ*RRR*VV + (ZZ*RRR*VV)' + HH;
GAMM0(:,1) = Gl(:);
   
TTl = TTT;
for l = 1:nlags;
    Gl = ZZ*(TTl*GA0)*ZZ' ;% + ZZ*(TTl*RRR*VV);
    GAMM0(:,l+1) = Gl(:);            
    TTl = TTl*TTT;
end

%% Create limit cross product matrices
yyyydcoint0 = reshape(GAMM0(:,1),nvar+ncoint,nvar+ncoint) + EZZZZ;
yyyydcoint1 = reshape(GAMM0(:,2),nvar+ncoint,nvar+ncoint) + EZZZZ;
yyyyd       = yyyydcoint0(1:nvar,1:nvar);

%% cointadd are treated as the first set of variables in XX
%% coint    are treated as the second set of variables in XX
%% composition: cointadd - coint - constant - lags
yyxxd = zeros(nvar,ncoint+1+nlags*nvar);
xxxxd = zeros(ncoint+1+nlags*nvar,ncoint+1+nlags*nvar);

%% E[yy,x(coint)]
yyxxd(:,1:ncoint) = yyyydcoint1(1:nvar,nvar+1:nvar+ncoint);

%% E[yy,x(constant)]
yyxxd(:,ncoint+1) = EZZ(1:nvar);

%% E[x(coint),x(coint)]
xxxxd(1:ncoint,1:ncoint) = yyyydcoint0(nvar+1:nvar+ncoint,nvar+1:nvar+ncoint);

%% E[x(const),x(const)]
xxxxd(ncoint+1,ncoint+1) = 1;

%% E[x(coint),x(const)]
xxxxd(1:ncoint,ncoint+1) = EZZ(nvar+1:nvar+ncoint);
xxxxd(ncoint+1,1:ncoint) = xxxxd(1:ncoint,ncoint+1)';

%% E[x(const),x(lags)]
xxxxd(ncoint+1,ncoint+1+1:ncoint+1+nlags*nvar) = kron(ones(1,nlags),EZZ(1:nvar)');
xxxxd(ncoint+1+1:ncoint+1+nlags*nvar,ncoint+1) = xxxxd(ncoint+1,ncoint+1+1:ncoint+1+nlags*nvar)';

for rr = 1:nlags;
    %% E[yy,x(lag rr)]
    yyyydcointrr = reshape(GAMM0(:,rr+1),nvar+ncoint,nvar+ncoint) + EZZZZ;
    yyxxd(:,ncoint+1+nvar*(rr-1)+1:ncoint+1+nvar*rr) = yyyydcointrr(1:nvar,1:nvar);

    %% E[x(coint),x(lag rr)]
    yyyydcointrr1 = reshape(GAMM0(:,rr),nvar+ncoint,nvar+ncoint) + EZZZZ;    
    xxxxd(1:ncoint,ncoint+1+nvar*(rr-1)+1:ncoint+1+nvar*rr) = yyyydcointrr1(nvar+1:nvar+ncoint,1:nvar);
    xxxxd(ncoint+1+nvar*(rr-1)+1:ncoint+1+nvar*rr,1:ncoint) = yyyydcointrr1(nvar+1:nvar+ncoint,1:nvar)';
    
    %% E[x(lag rr),x(lag ll)]
    for ll = rr:nlags;  
        yyyydcointrrll = reshape(GAMM0(:,ll-rr+1),nvar+ncoint,nvar+ncoint)+EZZZZ;
        xxxxd(ncoint+1+nvar*(rr-1)+1:ncoint+1+nvar*rr,ncoint+1+nvar*(ll-1)+1:ncoint+1+nvar*ll) = yyyydcointrrll(1:nvar,1:nvar);
        xxxxd(ncoint+1+nvar*(ll-1)+1:ncoint+1+nvar*ll,ncoint+1+nvar*(rr-1)+1:ncoint+1+nvar*rr) = yyyydcointrrll(1:nvar,1:nvar)';
    end
end
xxyyd = yyxxd';
clear yyxxd;

save varprio_my.mat