function [ L , exitflag] = kalman(Theta,data,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu); 
% this is the Kalman filter we need to use

[gx,hx,exitflag] = deep_run( Theta, f, fx, fy, fxp, fyp);
x = Theta;
steady_state();

if ( exitflag == 1 )

    F = hx;
   
    STD_EPSG     = Theta(end-7);
    STD_EPSMUZ   = Theta(end-6);
    STD_EPSMUUPS = Theta(end-5);
    STD_EPSD     = Theta(end-4);
    STD_EPSP     = Theta(end-3);
    STD_EPSW     = Theta(end-2);
    STD_EPSR     = Theta(end-1);
    STD_EPStau   = Theta(end);

    var_cu = [controlvar_cu statevar_cu];
    ng     = find(var_cu == 'g_cu'     );
    noutput= find(var_cu == 'output_cu');
    nmuc   = find(var_cu == 'muc_cu'   );
    nmuiv  = find(var_cu == 'muiv_cu'  );
    nmuw   = find(var_cu == 'muw_cu'   );
    nr     = find(var_cu == 'r_cu'     );
    ni     = find(var_cu == 'iv_cu'    );
    nc     = find(var_cu == 'c_cu'     );
    npi    = find(var_cu == 'pai_cu'   );
    nw     = find(var_cu == 'w_cu'     );
    nh     = find(var_cu == 'h_cu'     );
    ntau   = find(var_cu == 'tau_cu'   );
    
    smuz   = find(statevar_cu == 'muz_ba1');
    smuups = find(statevar_cu == 'muups_ba1');
    sd     = find(statevar_cu == 'd_ba1');
    sg     = find(statevar_cu == 'epsg_ba1');
    sr     = find(statevar_cu == 'mur_ba1');
    stau   = find(statevar_cu == 'epstau_ba1');
    sp     = find(statevar_cu == 'upsp_ba1');
    sw     = find(statevar_cu == 'upsw_ba1');
%     sp     = find(statevar_cu == 'epsp_ba1');
%     sw     = find(statevar_cu == 'epsw_ba1');

   
    sizex = length(statevar_cu);
    Q = zeros(sizex, sizex);
    Q(sg,sg)         = STD_EPSG^2;  
    Q(smuz,smuz)     = STD_EPSMUZ^2;
    Q(smuups,smuups) = STD_EPSMUUPS^2;
    Q(sd,sd)         = STD_EPSD^2;
    Q(sp,sp)         = STD_EPSP^2;
    Q(sw,sw)         = STD_EPSW^2;
    Q(sr,sr)         = STD_EPSR^2;
    Q(stau,stau)     = STD_EPStau^2;
   
    %A     = [gx; eye(nx)];
    THETA = 0.3;   
    %muzstarp = hx(smuz,:) + THETA/(1-THETA)*hx(smuups,:);
%   H(1,:) = A(ni,:)*(hx - eye(size(hx))) + muzstarp + hx(smuups,:);
%   H(2,:) = A(nc,:)*(hx - eye(size(hx))) + muzstarp;
%   H(3,:) = A(ny,:)*(hx - eye(size(hx))) + muzstarp;
%   H(4,:) =   A(npi,:);
%   H(5,:) = 4*A(nr ,:);
%     H(1,:) = A(ni,:)*(hx - eye(size(hx)))+ hx(smuz,:) + 1  /(1-0.3)*hx(smuups,:);
%     H(2,:) = A(nc,:)*(hx - eye(size(hx)))+ hx(smuz,:) + 0.3/(1-0.3)*hx(smuups,:);
%     H(3,:) = A(npi,:);
%     H(4,:) = A(nw,:)*(hx - eye(size(hx)))+ hx(smuz,:) + 0.3/(1-0.3)*hx(smuups,:);
%     H(5,:) = A(nh,:);
%     H(6,:) = A(ng,:);%*(hx - eye(size(hx)))+ hx(smuz,:) + 0.3/(1-0.3)*hx(smuups,:);
%     H(7,:) = 4*A(nr,:);
%     H(8,:) = A(ntau,:);
  
    ey = eye(sizex);
    H  = [];
    %H = [ H; gx(ng,:) - gx(noutput,:)];
    H  = [ H; ey(sg,:)];%[ H; gx(ng,:)*(hx - eye(size(hx)))+ hx(smuz,:)+ THETA/(1-THETA)*hx(smuups,:)]; %*(hx - eye(size(hx)))+ hx(smuz,:) + 0.3/(1-0.3)*hx(smuups,:);
%    H  = [ H; gx(ng,:)*(hx - ey)+ hx(smuz,:)+ THETA/(1-THETA)*hx(smuups,:)];
    H  = [ H; gx(ntau,:) ];
    
    %H  = [ H; gx(nc,:)*(hx - ey)+ hx(smuz,:)+ THETA/(1-THETA)*hx(smuups,:)];
    %H  = [ H; gx(ni,:)*(hx - ey)+ hx(smuz,:)+   1  /(1-THETA)*hx(smuups,:)];
     H  = [ H; gx(nmuc,:) ];
     H  = [ H; gx(nmuiv,:)];
    
    H  = [ H; gx(nh,:)];
    
    %H  = [ H; gx(nw,:)*(hx - ey)+ hx(smuz,:) + THETA/(1-THETA)*hx(smuups,:)];
     H  = [ H; gx(nmuw,:) ];
    
    H  = [ H; 4*gx(npi,:)];
    H  = [ H; 4*gx(nr,:)];

%    save H.mat H
    
    number_observables = size(H,1);
    number_states      = size(F,1);
    length_sample      = size(data,1);

    % Variance of measurement errors
    R = zeros(number_observables);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Following Hamilton the loglikelihood will be:
    % -T*n/2*log(2*pi)-1/2*(SUM(log(|H'Pt|t-1H+R|))+SUM(yt-A'xt-H'chi_t|t-1)'(H
    % 'Pt|t-1H+R)^-1*(yt-A'xt-H'chi_t|t-1))
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    % Starting the recursion, pg 378 of Hamilton
    % Inital forecasted states INITIAL GUESS(in Hamilton notation chi_1|0)
    x = zeros(number_states,1);
    % initial errors of forecasted states: In Hamilton notation this is P_1|0
    % P   = ones(number_states,number_states);
    % P   = inv(eye(number_states^2)-kron(F,F))*reshape(Q,number_states^2,1);
    % P   = reshape(P,number_states,number_states);

    %Doubling algorithm
    hx_old=hx;
    sig_old=Q;
    sigx_old=eye(size(hx));
    diferenz=.1;
    while diferenz>1e-25;
        sigx=hx_old*sigx_old*hx_old'+sig_old;
        diferenz = max(max(abs(sigx-sigx_old)));
        sig_old=hx_old*sig_old*hx_old'+sig_old;
        hx_old=hx_old*hx_old;
        sigx_old=sigx;
    end    %while diferenz
    P=sigx_old;

    %EVALUATING LOGLIKELIHOOD (CONSTANT TERM FIRST)
    L = -length_sample*number_observables*log(2*pi)/2;
    %Other parts of the likelihood depend on time, so they go in the loop:
    for i = 1:length_sample;
        obs = data(i,:)';
        % Gram-Schmidt residuals: observations-forecast (Hamilton
        % yt-H'*chi-A'*x)
        % res = obs-C*x;
        res = obs-H*x;
        varfy = H*P*H' + R; %(Hamilton H'PH+R)
        L1=det(varfy);
        if (L1 <=0)
            L = -inf;
            save kalman_res.mat
            return
        end
        invvarfy=inv(varfy);
        % Quadratic form associated with residuals
        L2 = res'*invvarfy*res;   %changes in each iteration
        L = L-(log(L1)+L2)/2;
        %Lcheck(i,1) = L;
        % UPDATING
        % Useful notation (Hamilton 13.2.19)
        K=(F*P*H')*invvarfy;
        % UPDATE X (Hamilton 13.2.20)
        x=F*x+K*res;
        % UPDATE P (Hamilton 13.2.22)
        P=F*(P-P*H'*invvarfy*H*P)*F'+Q;
        % or (just checking)
        %P=A*P*A'+BB-A*P*C'*invvarfy*C*P*A';
        %or Hamilton 13.2.28 (doublecheck)
        %P=(A-K*C)*P*(A'-C'*K')+K*DD*K'+BB;
    end %(ending for loop)
       % save P.mat P
       % save Lcheck.mat Lcheck
else
    L=-Inf;
end
save kalman_res.mat