function [series, YYall,XXall,ti] = loaddata(npath)

global T0 coint nvar nlags nconst
%npath = 'C:\Users\anutako\Dropbox\Research\Government_Spending\data\';
% start 1954:3 end 2010:4
%GDPR  = xlsread([npath,'NIPATable_GDPR.xlsx'       ],'ag7:jn7'    );  % SA, Quarterly data 
%GDP   = xlsread([npath,'NIPATable_GDPN.xlsx'       ],'ag7:jn7'    );  % SA, Quarterly
%GOV   = xlsread([npath,'NIPATable_GDPN.xlsx'       ],'ag27:jn27'  );  % SA, Quarterly data  
%GOV   = xlsread([npath,'NIPATable_GDPN.xlsx'       ],'ag28:jn28'  );  % SA, Quarterly data  
%W     = xlsread([npath,'COMPNFB.xls'               ],'b50  : b291');  % 2014/4
%H     = xlsread([npath,'HOANBS.xls'                ],'b43  : b284');
%TR1   = xlsread([npath,'Taxrevenues_data_total.xls'],'o33:o258'   )';

%PCT   = xlsread([npath,'NIPATable_GovR.xlsx'       ],'ag9:jn9'    );   %SA, Quarterly data  
%TCI   = xlsread([npath,'NIPATable_GovR.xlsx'       ],'ag11:jn11'  );   %SA, Quarterly data  
%GSI   = xlsread([npath,'NIPATable_GovR.xlsx'       ],'ag13:jn13'  );   %SA, Quarterly data   
%TR = PCT + TCI + GSI;

GDPR  = xlsread([npath,'NIPATable_GDPR.xlsx'],'ag7:ix7'); %SA, Quarterly data 
GDP   = xlsread([npath,'NIPATable_GDPN.xlsx'],'ag7:ix7');%SA, Quarterly
GOV   = xlsread([npath,'NIPATable_GDPN.xlsx'],'ag27:ix27'); %SA, Quarterly data  
W     = xlsread([npath,'COMPNFB.xls' ],'b50  : b275');
H     = xlsread([npath,'HOANBS.xls'  ],'b43  : b268');
TR    = xlsread([npath,'Taxrevenues_data_total.xls'],'o33:o258')';

P_GDP = GDP./GDPR;

%FEDFUNDS     =  xlsread([npath,'FEDFUNDS.xls'],'b13:b738');
FEDFUNDS     =  xlsread([npath,'FEDFUNDS.xls'],'b13:b690');

% CONVERT FEDFUNDS TO QUARTERLY FREQUENCY AND REVERT FROM ANNUALIZED TO
% QUATERLY INTEREST
FEDFUNDS  = ( FEDFUNDS(1:end-2).*FEDFUNDS(2:end-1).*FEDFUNDS(3:end) ).^(1/3) ;
FEDFUNDS  = FEDFUNDS([1:3:end]);

%INVESTMENTS
% DURABLES     = xlsread([npath,'NIPATable_GDPN.xlsx'],'ag10:jn10'); %SA
% PRIVATEINVEST= xlsread([npath,'NIPATable_GDPN.xlsx'],'ag13:jn13'); %SA
DURABLES     = xlsread([npath,'NIPATable_GDPN.xlsx'],'ag10:ix10'); %SA
PRIVATEINVEST= xlsread([npath,'NIPATable_GDPN.xlsx'],'ag13:ix13'); %SA
I            = DURABLES + PRIVATEINVEST;
IR            = I./ P_GDP;

%CONSUMPTION
%SERVICES     = xlsread([npath,'NIPATable_GDPN.xlsx'],'ag12:jn12'); %SA
%NONDURABLES  = xlsread([npath,'NIPATable_GDPN.xlsx'],'ag11:jn11'); %SA
SERVICES     = xlsread([npath,'NIPATable_GDPN.xlsx'],'ag12:ix12'); %SA
NONDURABLES  = xlsread([npath,'NIPATable_GDPN.xlsx'],'ag11:ix11'); %SA
C            = SERVICES + NONDURABLES;
CR            = C./P_GDP;

WR    = W'./P_GDP;
GOVR  = GOV./P_GDP;

%read from bls
%laborforce  = xlsread([npath,'LaborForce.xlsx'],'d91:d816'); %Monthlydata , thousands of persons
laborforce  = xlsread([npath,'LaborForce.xls'],'d91:d768'); %Monthlydata , thousands of persons
laborforce  = ( laborforce(1:end-2) + laborforce(2:end-1) + laborforce(3:end) )/3 ;
laborforce  = laborforce([1:3:end])';

% Normalize by population ;
GDPR  = GDPR ./ laborforce ; 
CR    = CR   ./ laborforce ;
IR    = IR   ./ laborforce ;
H     = H'   ./ laborforce ;
GOVR  = GOVR ./ laborforce ;
GOV   = GOV  ./ laborforce ;
GDP   = GDP  ./ laborforce ;
TR    = TR   ./ laborforce ;

%series = [ diff(log( [  I' C' P_GDP' W'])) log(H(2:end))'  log(GOV(2:end)./GDP(2:end))' FEDFUNDS(2:end) log(TR(2:end)./GDP(2:end))'];
%size(log(GOV(2:end)./GDP(2:end))') size(log(TR(2:end)./GDP(2:end))') size(diff(log( [  I' C'  W']))) log(H(2:end))' 4*diff(log(P_GDP'))  FEDFUNDS(2:end))
series = [ log(GOVR(2:end)./GDPR(1:end-1))'  log(TR(2:end)./GDP(2:end))' diff(log(CR')) diff(log(IR'))  log(H(2:end))' diff(log(WR')) 4*diff(log(P_GDP'))  0.01*FEDFUNDS(2:end) ];

%series = [ diff(log((GOVR)')) log(TR(2:end)./GDP(2:end))' diff(log(CR'))  diff(log(IR')) log(H(2:end))' diff(log(WR')) 4*diff(log(P_GDP'))  0.01*FEDFUNDS(2:end)  ];
%diff(log((GOV./P_GDP)'))
%series = 100*[diff(log(GDPR')) diff(log(C')) diff(log(I')) 0.01*log(H(2:end))' diff(log(W')) 4*diff(log(P_GDP')) FEDFUNDS(2:end) ];
nobs   = size(series,1);
start_date = 1954.50;
ti     = (start_date:0.25:(start_date+.25*(nobs-1)))';   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%start_date = 1954.50;
%         %fname = strcat(fpath,'data',num2str(floor(dataset)),'.txt')
%         %data = importdata(fname);
%     %load C:\Users\anutako\Dropbox\Research\Government_Spending\RR_JMCB\DSGE_VAR\DelNegrofiles\euro090606\data4.txt
%     load data4.mat data
%         nobs   = size(data,1);
%         ti     = (start_date:0.25:(start_date+.25*(nobs-1)))';   
%         %% Compute growth rates
%         series  = zeros(nobs-1,size(data,2));
%         nobs = nobs -1;
%         ti = ti(2:end);
%         %% lgdprpc: log real GDP per capita
%         series(:,1) = 100*(log(data(2:end,1))-log(data(1:end-1,1)));
%         %% lconrpc: log nominal consumption deflated by GDP deflator per capita
%         series(:,2) = 100*(log(data(2:end,2))-log(data(1:end-1,2)));
%         %% linvrpc: log nominal investment deflated by GDP deflator per capita
%         series(:,3) = 100*(log(data(2:end,3))-log(data(1:end-1,3)));
%         %% lhoursuppc: log hours worked per capita
%         series(:,4) = 100*log(data(2:end,4));
%         %% lhupwin: log hourly real wage
%         series(:,5) = 100*(log(data(2:end,5))-log(data(1:end-1,5)));
%         %% lyed: log GDP deflator
%         series(:,6) = 400*(log(data(2:end,6))-log(data(1:end-1,6)));
%         %% stn : nominal short-term interest rate (Fed Fund)
%         series(:,7) = data(2:end,7);
        if coint > 0; 
           series_coint= zeros(nobs,coint);
           %% consumption - output
           series_coint(:,1) = log(C(2:end)./GDPR(2:end));
           %% labor share
           series_coint(:,2) = log(W(2:end)./GDPR(2:end));
        end
        YYall     = series(1+T0:nobs,:);
        XXall     = ones(nobs-T0, coint+nconst+nvar*nlags);

        i=1;
        ti       = ti(1+T0:nobs,:);
        for i = 1:nlags
           XXall(:,nconst+coint+(i-1)*nvar+1:nconst+coint+i*nvar) = series(T0-i+1:nobs-i,:);
        end
        
        if coint > 0
%           if cointadd == 0
              XXall(:,1:coint) = series_coint(T0:nobs-1,:);
              %XXall = [XXall;[series_coint(nobs,:),1,YYall(end,:),XXall(end,1+coint+1:1+coint+nvar*nlags-nvar)]];
        end
              %            else
%               XXall(:,1:cointadd) = series_cointadd(T0:nobs-1,:);
%               XXall(:,1+cointadd:coint) = series_coint(T0:nobs-1,:);
%               XXall = [XXall;[series_cointadd(nobs,:),series_coint(nobs,:),1,YYall(end,:),XXall(end,1+coint+1:1+coint+nvar*nlags-nvar)]];              
%            end
%        else
           %XXall = [XXall;[1,YYall(end,:),XXall(end,1+1:1+nvar*nlags-nvar)]];           
%        end
        
        %        nobs = size(YYall,1);
        VIEW = 0;
        if VIEW
            datt = [ti,YYall];
            FORMAT = '\n %2.2f  '; 
            for i = 1:nvar
                FORMAT = strcat(FORMAT,' %2.2f ');
            end
            fprintf(1,'\n\n Actual data  \n\n');
            fprintf(1,FORMAT,datt');
            for I = 1:size(YYall,2)
                plot(ti,YYall(:,I)); title(num2str(I));                      
                %print(char(strcat('C:\Users\anutako\Dropbox\Research\GOVSP1\program\','data',num2str(I),'.eps')),'-depsc');
                print(char(strcat('data',num2str(I),'.eps')),'-depsc');
                close all;
            end
            %series_coint = series_coint(1+T0:end,:);
            %% plot ratios
            figure(101)
            subplot(1,2,1); plot(ti,(series_coint(1+T0:end,1))); title('ln(C/Y)');
            subplot(1,2,2); plot(ti,(series_coint(1+T0:end,2))); title('ln(realW/Y)');
            set(figure(101),'PaperPosition',[0 0 8 6])
            %print(char(strcat('C:\Users\anutako\Dropbox\Research\GOVSP1\program\','data',num2str(floor(dataset)),'ratios.eps')),'-depsc');
            print(char(strcat('data',num2str(floor(dataset)),'ratios.eps')),'-depsc');
        end
        
%size(YYall)
%size(series)
%save load_data.mat