clear all
clc
close all

global nvar nlags ncoint nconst T0 coint
global nobs Pmean Pstd

datapath  = 'C:\Users\anutako\Dropbox\Research\Government_Spending\data\';

restoredefaultpath
currentpath = pwd;
model = 'DH';

pathname = [currentpath(1:end-length(model))];
eval(['addpath ',pathname,'MODEL'])
coint = 0; ncoint = 0; nconst = 0; nlags = 4; nvar = 8;
T0 = nlags;
[series, data] = loaddata(datapath);
nobs = size(data,1);
nvar = size(data,2);

for i = 1:nvar
    data(:,i) = data(:,i) - mean(data(:,i));
end
% fid = fopen('mdata8.txt','w');
% for i = 1:nvar
%     for j = 1:nobs
%         fprintf(fid,[ num2str(data(j,i),'%10.16f') , '\r\n']);
%     end
% end
% fclose(fid);

rand('state',sum(100*clock))
varspec();

format long g

load mean_est.txt
Theta = mean_est';

[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;
[loglike, exitflag] = kalman(Theta,data,f, fx, fy, fxp, fyp, statevar_cu,controlvar_cu)
return
acc   = 0;
count = 0;
% hessian = 1;
% if hessian == 1 
%      hessian_x     = fn_hesscd(Theta,1.e-05,YYYY,XXYY,XXXX,f, fx, fy, fxp, fyp, statevar_cu,controlvar_cu);
%      H0            = -inv(hessian_x);
%      [V,D]         = eig(H0);
%      D             = abs(D);
%      H0            = V*D*V';
%      D             = chol(H0);
% else
%       D = 1;
% end
% save hess.mat D 
% return

load hess.mat D

sig_th = 0.03;
tic;
Niter = 1000000;
for j = 1:Niter
    if rem(j,10000) == 0  
       [ j  loglike acc ]
       Theta
    end
    exitflag = 0;
    while exitflag ~= 1
        newTheta  = Theta + (sig_th*randn(size(Theta)))*D;
        newlogpri = priordeephabits(newTheta);
        while newlogpri == -inf 
            newTheta  = Theta + (sig_th*randn(size(Theta)))*D;%mvnrnd(zeros(1,length(Theta)), variance_normal); 
            newlogpri = priordeephabits(newTheta);
        end
        %[newloglike, exitflag] = kalman(newTheta,data,f, fx, fy, fxp, fyp,statevar_cu,controlvar_cu,statevar_cup,controlvar_cup);
         newloglike = objfcnmh(newTheta,YYYY,XXYY,XXXX,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);
    end
        if newloglike==-Inf;
                ratio=0;
        else
                ratio = exp(newloglike + newlogpri - (loglike + logpri));
                count = count + 1;
                if rand <= ratio % we accept with prob ratio
                        loglike = newloglike;
                        logpri  = newlogpri;
                        Theta   = newTheta;
                        acc     = acc + 1; % keeping track of the acceptances
                end
        end
        Theta_s(j,:)   = Theta;
        loglike_s(j,1) = loglike;
        logpri_s(j,1)  = logpri;
end
Theta           = mean(Theta_s,1);
acceptance_rate = acc/Niter*100;

toc
hours=toc/3600