%function [RHOupsP, RHOupsW, UPSP, UPSW, MUw, MUp, TAU, EPSTAU, RHOtau, ALFA_tau, ALFA_tauy, EPSG, QQ, EPSW, EPSP, MC, ZZETA PSSI, MUUPS, MUZ, RHOw, RHOp, RHOMUZ, RHOMUUPS, RHOPREF, RHOGG, RHOR, RHOC,RHOG, BC, BG, KAPA, ETA, ETATIL, ALFA, ALFATIL, GAMAI, GAMAII, ALFA_R, ALFA_PAI, ALFA_Y, SSIGMA, BETTA, THETA, DELTA, R, W, PAI, K, G, D, MUTIL, OUTPUT, U, IV, H, C, CS, GS, CNUTIL, GNUTIL, MUZSTAR] = steady_state(x);

TAU      = 0.18;
RHOtau   = 0;

RHOupsP  = 0;
RHOupsW  = 0;
UPSP     = 1;
UPSW     = 1;
EPSTAU   = 1;
EPSP     = 1;
EPSW     = 1;

QQ       = 1;
MUR      = 1;
ETA      = 6;
ETATIL   = 21;

U        = 1;
PAI      = 1.0086;%1.042^(1/4); %Inflation
BETTA    = 0.999; %Discount factor;
THETA    = 0.3;%0.36; %Capital share; I use a much smaller capital share to avoid the problem of getting an investment share of over 1/3 of GDP.
DELTA    = 0.025; 
MUZSTAR  = 1.0047; % steady state growth rate of output is 0.0047
MUUPS    = 1.0042; % ACEL
D        = 1;
RHOR     = 0.0;
SHAREG   = 0.2; % Share of gov't expenditures in gdp 
EPSG = SHAREG*MUZSTAR;

BC       = x(1);%0.6;
RHOC     = x(2);%0.8;
BG       = x(3); %  
RHOGG    = x(4); %  

ALFA     = x(5);%0.8
ALFATIL  = x(6);%20
ALFA_R   = x(7);%0.5;
ALFA_PAI = x(8);%1;
ALFA_Y   = x(9);%0.2;
KAPA     = x(10);%3;
GAMAII_GAMAI = x(11);%2.0
SSIGMA    = x(12);
ALFA_tau = x(13);
ALFA_tauy= x(14);
RHOG     = x(15);%0.2;
RHOMUZ   = x(16);%0.8;
RHOMUUPS = x(17);%0.8;
RHOPREF  = x(18);%0.8;
RHOp     = x(19);
RHOw     = x(20);
MUp      = x(21);
MUw      = x(22);

MUZ      = MUZSTAR/ MUUPS^(THETA/(1-THETA));
MUI      = MUUPS * MUZSTAR; 
%R        = MUZSTAR^(1-SSIGMA)* PAI / BETTA; % Nominal interest rate !!!!
R        = MUZSTAR* PAI / BETTA; % Nominal interest rate !!!!
RK       = (MUI/BETTA -1 + DELTA)/(1-TAU); % Rental rate of capital

MUTIL    = ETATIL / (ETATIL-1)/(1-TAU);
%COMPONENTS FOR STEADY STATE MC
SHAREI   = (MUI - (1-DELTA) ) * THETA /U/ RK;%( MUUPS/BETTA/MULAMBDA -1 + DELTA );
SHAREC   = 1  - SHAREG - SHAREI; %Consumption share in gdp (this includes the transactions cost

AAC      =  1 - BC*(1 - RHOC)/(MUZSTAR-RHOC);
BBC      =  1 - BC*(1 - RHOC)/(MUZSTAR/BETTA - RHOC ); %!!!
AAG      =  1 - BG*(1 - RHOGG)/(MUZSTAR-RHOGG);
BBG      =  1 - BG*(1 - RHOGG)/(MUZSTAR/BETTA - RHOGG );  %!!!
MC       =  1 - 1/ ETA / ( SHAREC*AAC/BBC + SHAREG*AAG/BBG  + SHAREI);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CNUTIL   = (1-MC)/BBC;
GNUTIL   = (1-MC)/BBG;

K_H     = MUI/U*(RK/MC/THETA)^(1/(THETA-1)); % Aggregate capital factor input
IV_H    = (1-(1-DELTA)/MUI) * K_H; % investment
W       = MC * (1-THETA) * (U*K_H/MUI)^THETA; % Average real wage rate
OUTPUT_H= MC*(U*K_H/MUI)^THETA ; % Aggregate absorption
PSSI_H  = (1-MC)*(U*K_H/MUI)^THETA;
G_H     = SHAREG * OUTPUT_H;  % Government spending
C_H     = OUTPUT_H - IV_H - G_H ; % Private consumption
%H      = ((1-BC)*C_H*MUTIL/W)^(-1/(1+SSIGMA));
%H       = (C_H*MUTIL/W*(1-BC*(1-RHOC)/(MUZSTAR-RHOC)))^(-1/(ZZETA+1)); %!!!
%XI      = W/MUTIL/ZZETA/H^ZZETA/(C_H*(1-BC*(1-RHOC)/(MUZSTAR-RHOC)));
CS_H    = (1-RHOC)*C_H/(1-RHOC/MUZSTAR); %STEADY STATE OF SHARE OF HABIT STOCK OF CONSUMPTION
%XX_H    = C_H - BC *CS_H /MUZSTAR; %!!!
%H = (W/MUTIL/XX_H)^(1/(ZZETA+1));
%H = (W/MUTIL)^(1/(ZZETA));
%H      = (C_H*(1-BC*(1-RHOC)/(MUZSTAR-RHOC))*MUTIL/W)^(-1/(1+SSIGMA));
H = 0.5;
%ZZETA = - 1 + W/MUTIL*(SSIGMA-1)/(C_H - BC *CS_H/MUZSTAR);

C       = C_H*H;
G       = G_H*H;
IV      = IV_H*H;
K       = K_H*H;
OUTPUT  = OUTPUT_H * H ;
%B = 0;
T       = G;
%T        = (W*H - C);
%B        = (G-T)/(1/R-1/PAI/MUZSTAR);
PSSI    = PSSI_H*H;
CS      = (1-RHOC)*C/(1-RHOC/MUZSTAR); %STEADY STATE OF SHARE OF HABIT STOCK OF CONSUMPTION
GS      = (1-RHOGG)*G/(1-RHOGG/MUZSTAR); %STEADY STATE OF SHARE OF HABIT STOCK OF GOVERNMENT CONSUMPTION
% XX      = C - BC *CS /MUZSTAR; %!!!
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%LA       = D/(C-BC*CS/MUZSTAR);
%LA        = D * ((C-BC*CS/MUZSTAR)*(1-H^(ZZETA+1)/(ZZETA+1)))^(-SSIGMA);
%LA        = D * ( C-BC*CS/MUZSTAR - H^(ZZETA+1)/(ZZETA+1))^(-SSIGMA)
ZZETA = (1-TAU)*W/MUTIL*(1-H)*(1-SSIGMA)/ (C - (BC*CS)/MUZSTAR);
LA        = D *(C-BC*CS/MUZSTAR)^(-SSIGMA) * H^(ZZETA);
if  LA < 0
    output = 1;
end
%SSIGMA    = log(LA*MC*(1-THETA)*(K/H)^THETA)/log(H);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
GAMAI = (1-TAU)*RK/QQ;
GAMAII   = GAMAII_GAMAI*GAMAI;
BETTA = BETTA/MUZSTAR^(1-SSIGMA);

MUC  = MUZSTAR; 
MUIV = MUI;
MUW  = MUZSTAR; 