function [f, fx, fy, fxp, fyp,  statevar_cu,statevar_cup,controlvar_cu,controlvar_cup]=competitive_eqm;

allsyms
constraints_cu = constraints();

%Complete set of equilibrium conditions a a system of first-order nonlinear
%difference equations
foc = [ constraints_cu];
%VARR_ST   = [ XX      MUZSTAR      MUTIL      OUTPUT       U       QQ       IV       W       H        C       LA        PAI       MC      K      R      CS      GS      SI        CNUTIL       GNUTIL     NUTILI       D      G       MUUPS      MUZ     MUR       EPSG   EPSW   EPSP];
%[VARR_ST, varr_cu varr_cup varr_ba1 varr_ba1p varr_ba2 varr_ba2p varr_ba3 varr_ba3p varr_ba4, varr_ba4p varr_fu1, varr_fu1p ] = vars_t;
vars_t();
% FORM CONSTRAINTS, CONTROL AND STATE VARIABLES VECTORS
%find state variables with index _ba1 or lower
varr  = [varr_ba1  varr_ba2  varr_ba3];
varr1 = [varr_ba1p varr_ba2p varr_ba3p];
VARR  = [VARR_ST VARR_ST VARR_ST VARR_ST];

% Form vector of state variables
statevar_cu  = [ ];
statevar_cup = [ ];
STATEVAR     = [ ];
for i = 1:length(varr)
    if ( sum(diff(foc, varr(i)) ~= zeros(size(foc))) ~= 0 | sum(diff(foc, varr1(i)) ~= zeros(size(foc))) ~= 0 )
        statevar_cu  = [ statevar_cu  varr(i)  ];
        statevar_cup = [ statevar_cup varr1(i) ];
        STATEVAR     = [ STATEVAR     VARR(i)  ];
    end
end

%Form vector of control variables
varr  = [varr_cu  varr_fu1 ];
varr1 = [varr_cup varr_fu1p];
VARR  = [VARR_ST  VARR_ST  ];

controlvar_cu  = [ ];
controlvar_cup = [ ];
CONTROLVAR     = [ ];
for i = 1:length(varr)
    if ( sum(diff( foc, varr(i)) ~= zeros(size(foc))) ~= 0 | (sum(diff( foc, varr1(i)) ~= zeros(size(foc))) ~= 0 & sum(diff( foc, varr(i)) ~= zeros(size(foc))) == 0))
        controlvar_cu  = [ controlvar_cu  varr(i)  ];
        controlvar_cup = [ controlvar_cup varr1(i) ];
        CONTROLVAR     = [ CONTROLVAR     VARR(i)  ];
    end
end

% establish links between _cu and _ba1p; _fu1 and _cup and _ba1 and _ba2p
vs      = [statevar_cu, controlvar_cu, statevar_cup, controlvar_cup];
VS      = [STATEVAR     CONTROLVAR     STATEVAR      CONTROLVAR    ];

varr  = [varr_cu   varr_fu1 varr_ba1  varr_ba2  varr_ba3  ]; 
varr1 = [varr_ba1p varr_cup varr_ba2p varr_ba3p varr_ba4p ]; 

links   = [];
if (1 == 12)
%if (1 == 1) % needed for Sarah's code to run
    for i = 1:length(varr)
        for j = 1:length(vs)
           if ( isequaln( vs(j), varr(i) ) == 1 )
               for k = 1:length(vs)
                   if( isequaln( vs(k), varr1(i)) == 1  )
                       links = [ links; -varr(i) + varr1(i)];
                       break
                   end
               end
           end
        end
    end
else
    for i = 1:length(varr)
        if ( sum( vs == varr(i) ) ~= 0 &  sum( vs == varr1(i)) ~= 0  )
            links = [ links; -varr(i) + varr1(i)];
        end
    end
end
f = [ foc; links ];

%Make f a function of the logarithm of the state and control vector controls in logs
%variables to substitute from levels to logs
f    = subs(f, vs, exp(vs));

%Compute analytical derivatives of f
fx  = jacobian(f,statevar_cu);
fxp = jacobian(f,statevar_cup);
fy  = jacobian(f,controlvar_cu);
fyp = jacobian(f,controlvar_cup);

f   = subs(f,  vs, log(VS));
fx  = subs(fx, vs, log(VS));
fy  = subs(fy, vs, log(VS));
fxp = subs(fxp,vs, log(VS));
fyp = subs(fyp,vs, log(VS));

% find non-zero elements of f, fx, fy,fxp and fyp to exclude from evaluation
f_nozero       = find(f(:)   ~= 0 );
fx_nozero      = find(fx(:)  ~= 0 );
fxp_nozero     = find(fxp(:) ~= 0 );
fy_nozero      = find(fy(:)  ~= 0 );
fyp_nozero     = find(fyp(:) ~= 0 );
% Now write f-s into txt file for the fortran code
var_cu = [controlvar_cu statevar_cu];
fid = fopen('fxfyfxpfypf.f90','w');
fprintf(fid,'SUBROUTINE fxfyfxpfypf(x, nf, nfx, nfxp, nfy, nfyp, sizef, sizex, sizey, smuz, smuups, sd, sg, noutput, nc,  nw, signout)  \n');
   
fprintf(fid,'IMPLICIT NONE \n');
fprintf(fid,['REAL(8), INTENT(IN)  :: Thetta(num_theta) \n']);
fprintf(fid,['REAL(8), INTENT(OUT) :: nf(sizef), nfx(sizef*sizex), nfxp(sizef*sizex), nfy(sizef*sizey), nfyp(sizef*sizey)  \n']);
fprintf(fid,['REAL(8)              :: R, W, PAI, K, G, D, MUTIL, OUTPUT, U, IV, H, C, SC, SG, NUTILC, NUTILG, MUZSTAR  \n']); 
fprintf(fid,['REAL(8)              :: yout(43), PSSI, MUUPS, MUZ, RHOMUZ, RHOMUUPS,  RHOPREF, RHOGG, RHOC,RHOG, BC, BG, HB \n']);
fprintf(fid,['REAL(8)              :: KAPA, ETA, ETATIL, CHI, CHITIL, ALFA, ALFATIL, GAMAI, GAMAII, ALFA_PAI, SIGMA, BETTA, THETA, DELTA \n']);
fprintf(fid,['INTEGER, INTENT(OUT) :: smuz, smuups, sd, sg, noutput, nc,  nw, signout \n']); 

fprintf(fid,['CALL steady_state(Thetta,signout,yout) \n']);

fprintf(fid,['smuz   = ', num2str(find(statevar_cu == 'muz_ba1'      )),' \n']);
fprintf(fid,['smuups = ', num2str(find(statevar_cu == 'muups_ba1'    )),' \n']);
fprintf(fid,['sd     = ', num2str(find(statevar_cu == 'd_ba1'        )),' \n']);
fprintf(fid,['sg     = ', num2str(find(statevar_cu == 'epsg_ba1'    )),' \n']);
fprintf(fid,['sw     = ', num2str(find(statevar_cu == 'upsw_ba1'    )),' \n']);
fprintf(fid,['sp     = ', num2str(find(statevar_cu == 'upsp_ba1'    )),' \n']);
%fprintf(fid,['sw     = ', num2str(find(statevar_cu == 'epsw_ba1'    )),' \n']);
%fprintf(fid,['sp     = ', num2str(find(statevar_cu == 'epsp_ba1'    )),' \n']);
fprintf(fid,['sr     = ', num2str(find(statevar_cu   == 'mur_ba1'   )),' \n']);
fprintf(fid,['stau     = ', num2str(find(statevar_cu == 'epstau_ba1'   )),' \n']);
fprintf(fid,['noutput= ', num2str(find(controlvar_cu == 'output_cu' )),' \n']);
fprintf(fid,['nc     = ', num2str(find(controlvar_cu == 'c_cu'      )),' \n']);
%fprintf(fid,['ng     = ', num2str(find(var_cu == 'epsg_ba1'  )),' \n']);
fprintf(fid,['ng     = ', num2str(find(controlvar_cu == 'g_cu'  )),' \n']);
fprintf(fid,['nmuc   = ', num2str(find(controlvar_cu == 'muc_cu'      )),' \n']);
fprintf(fid,['nmuiv  = ', num2str(find(controlvar_cu == 'muiv_cu'      )),' \n']);
fprintf(fid,['nmuw   = ', num2str(find(controlvar_cu == 'muw_cu'      )),' \n']);
fprintf(fid,['nw     = ', num2str(find(controlvar_cu == 'w_cu'      )),' \n']);
fprintf(fid,['nh     = ', num2str(find(controlvar_cu == 'h_cu'      )),' \n']);
fprintf(fid,['niv    = ', num2str(find(controlvar_cu == 'iv_cu'     )),' \n']);
fprintf(fid,['npi    = ', num2str(find(controlvar_cu == 'pai_cu'    )),' \n']);
fprintf(fid,['nr     = ', num2str(find(controlvar_cu == 'r_cu'      )),' \n']);
fprintf(fid,['ntau   = ', num2str(find(controlvar_cu == 'tau_cu'    )),' \n']);

fprintf(fid,['sizef  = ', num2str(length(f)),' \n']);
fprintf(fid,['sizex  = ', num2str(length(statevar_cu )),' \n']);
fprintf(fid,['sizey  = ', num2str(length(controlvar_cu)),' \n']);

fprintf(fid,'nf = 0.0D+0 \n nfx = 0.0D+00 \n nfxp = 0.0D+00 \n');
fprintf(fid,'nfy = 0.0D+00 \n nfyp = 0.0D+00 \n');

for i = 1: length(f_nozero)
    fprintf(fid,['nf(',num2str( f_nozero(i)), ') = ',char(f(f_nozero(i))),'\n']);
end
fprintf(fid,'DO i = 1, sizef \n IF ( ABS(nf(i)) > 1.0D-5) THEN \n');
fprintf(fid,'signout = 1 \n nfx = 0.0D00 \n nfy = 0.0D+00 \n nfxp = 0.0D+00 \n nfyp = 0.0D+00 \n');
fprintf(fid,' write(*,*)  nf \n RETURN \n');
fprintf(fid,' END IF \n END DO \n');
for i = 1: length(fx_nozero)
    fprintf(fid,['nfx(',num2str( fx_nozero(i)), ') = ',char(fx(fx_nozero(i))),'\n']);
end
for i = 1:size(fy_nozero)
    fprintf(fid,['nfy(',num2str( fy_nozero(i)), ') = ',char(fy(fy_nozero(i))),'\n']);
end
for i = 1:size(fxp_nozero)
    fprintf(fid,['nfxp(',num2str( fxp_nozero(i)), ') = ',char(fxp(fxp_nozero(i))),'\n']);
end
for i = 1:size(fyp_nozero)
    fprintf(fid,['nfyp(',num2str( fyp_nozero(i)), ') = ',char(fyp(fyp_nozero(i))),'\n']);
end
fprintf(fid,'END SUBROUTINE fxfyfxpfypf');
fclose(fid);