function series = load_data();

% start 1954:3 end 2010:4
GDPR  = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\NIPATable_GDPR.xlsx','ag7:ix7'); %SA, Quarterly data 
GDP   = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\NIPATable_GDPN.xlsx','ag7:ix7');%SA, Quarterly
GOV   = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\NIPATable_GDPN.xlsx','ag27:ix27'); %SA, Quarterly data  
W     = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\COMPNFB.xls' ,'b50  : b275');
H     = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\HOANBS.xls'  ,'b43  : b268');
TR    = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\Taxrevenues_data_total.xls','o33:o258')';

P_GDP = GDP./GDPR;
WR     = W'./P_GDP;
GOVR = GOV./P_GDP;

FEDFUNDS     =  xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\FEDFUNDS.xls','b13:b690');

% %NOMINAL INVESTMENTS
DURABLES     = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\NIPATable_GDPN.xlsx','ag10:ix10'); %SA
PRIVATEINVEST= xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\NIPATable_GDPN.xlsx','ag13:ix13'); %SA
I            = DURABLES + PRIVATEINVEST;
IR            = I./ P_GDP;

%CONSUMPTION
SERVICES     = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\NIPATable_GDPN.xlsx','ag12:ix12'); %SA
NONDURABLES  = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\NIPATable_GDPN.xlsx','ag11:ix11'); %SA
C            = SERVICES + NONDURABLES;
CR            = C./P_GDP;

%read from bls
laborforce  = xlsread('C:\Users\anutako\Dropbox\Research\Government_Spending\data\LaborForce.xls','d91:d768'); %Monthlydata , thousands of persons
laborforce  = ( laborforce(1:end-2) + laborforce(2:end-1) + laborforce(3:end) )/3 ;
laborforce  = laborforce([1:3:end])';


% CONVERT FEDFUNDS TO QUARTERLY FREQUENCY AND REVERT FROM ANNUALIZED TO QUATERLY INTEREST
FEDFUNDS  = ( FEDFUNDS(1:end-2).*FEDFUNDS(2:end-1).*FEDFUNDS(3:end) ).^(1/3) ;
FEDFUNDS  = FEDFUNDS([1:3:end]);

% Normalize by population ;
GDPR  = GDPR ./ laborforce ; 
CR    = CR   ./ laborforce ;
IR    = IR   ./ laborforce ;
H     = H'   ./ laborforce ;
GOVR  = GOVR ./ laborforce ;
GOV   = GOV  ./ laborforce ;
GDP   = GDP  ./ laborforce ;
TR    = TR   ./ laborforce ;

series = [ log(GOVR(2:end)./GDPR(1:end-1))'  log(TR(2:end)./GDP(2:end))' diff(log(CR')) diff(log(IR'))  log(H(2:end))' diff(log(WR')) 4*diff(log(P_GDP'))  0.01*FEDFUNDS(2:end) ];
series = series(5:end,:);
save  series_1.mat 