clear all
close all
clc

restoredefaultpath
%addpath C:\Users\31049308\Dropbox\Research\GOVSP1\MODEL
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\MODEL
addpath C:\Users\Anna\Dropbox\Research\GOVSP1\fortran\2015_0602\PROD\LA04

global nvar nlags ncoint nconst Pmean nobs

varspec();
load mean_est.txt
lambda = 0.4*nobs;
nobsc = nobs+lambda;

VECM = 0;
[YY,XX,ti] = loaddata;
if (VECM == 0)
    XX = XX(:,ncoint+1:end);
end
YY = YY - kron(mean(YY),ones(length(YY),1));%kron(mean(YY),[1;1])
XX = XX - kron(mean(XX),ones(length(XX),1));
YYYY = YY'*YY;
XXYY = XX'*YY;
XXXX = XX'*XX;

IRFtime= 16;
count_explode = 0;
names = char('G','\tau','C','I','h','W','\pi','R');

PHIu = inv(XXXX)*XXYY; 
Sig_hat = (YYYY - XXYY'*PHIu)/nobs; % formula (29)

Sig   = chol(Sig_hat,'lower');
if nlags > 1
   eye(nvar*nlags);
   B = [ PHIu(1+nconst+ncoint:end,:)'; ans(1:nvar*(nlags-1),:) ];
else
   B = PHIu(1+nconst+ncoint:end,:)';
end
var_explode = sum(abs(eig(B))>1);
if var_explode > 0
   warning('VAR Explosive')
   count_explode = count_explode + 1;
end

shock = zeros(nvar,1);
shock(1)= 1;
IR = zeros(IRFtime,nvar);
for j = 1 : IRFtime
     B^(j-1);
     IR(j,:) = ans(1:nvar,1:nvar)*Sig*shock;
end
IRF_i = IR;
IRF_i(:,[3,4,6]) = cumsum(IRF_i(:,[ 3,4,6])); 
RESPONSES = IRF_i; 

h = figure
for i = 1:nvar
   subplot(4,2,  i)
   plot([1:1:IRFtime], RESPONSES(:,i), 'LineWidth',2,'Color',[0 0 0 ])
   axis tight
   title(names(i,:))
end
%suptitle('Data IRFs cholesky identificatoin')
print(h,'-dps','Chol_data_IRFS.eps')
print(h,'-dpdf','Chol_data_IRFS.pdf')

k = size(XXXX,1);

[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;

sizex = length(statevar_cu);
sizey = length(controlvar_cu);

smuz    = find( statevar_cu == 'muz_ba1'    );
smuups  = find( statevar_cu == 'muups_ba1'  );
sd      = find( statevar_cu == 'd_ba1'      );
sg      = find( statevar_cu == 'epsg_ba1'   );
sr      = find( statevar_cu == 'mur_ba1'    );
stau    = find( statevar_cu == 'epstau_ba1' );
sp      = find( statevar_cu == 'upsp_ba1'   );
sw      = find( statevar_cu == 'upsw_ba1'   );
ng      = find(controlvar_cu == 'g_cu'      );
nr      = find(controlvar_cu == 'r_cu'     );
ni      = find(controlvar_cu == 'iv_cu'    );
nc      = find(controlvar_cu == 'c_cu'     );
npi     = find(controlvar_cu == 'pai_cu'   );
nw      = find(controlvar_cu == 'w_cu'     );
nh      = find(controlvar_cu == 'h_cu'     );
noutput = find(controlvar_cu == 'output_cu');
ntau    = find(controlvar_cu == 'tau_cu'   );

IRFtime= 16;
count_explode = 0;

num_theta = length(mean_est);
y = [];
for i = 1:num_theta
    eval(['load x',num2str(i),'_PROD.txt' ])
    eval(['hlp = x', num2str(i), '_PROD;' ])
    y = [y   hlp];
end

vectr = [ sg stau smuz smuups sd sw sp sr ];
ran   = randi([ 1 length(y)],1,100);

for b = 1:length(ran)
    b
    Theta = y(ran(b),:);
    [yyyyd,xxyyd,xxxxd, ZZ,gx,hx, MM, gxz] = varprio(Theta,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);

    yyyyc = (YYYY + lambda*yyyyd)/nobsc;
    xxyyc = (XXYY + lambda*xxyyd)/nobsc;
    xxxxc = (XXXX + lambda*xxxxd)/nobsc;
    
    invxxxxc = inv(xxxxc);
    PHI = invxxxxc*xxyyc; 
    Sig_hat = (yyyyc - xxyyc'*PHI);
    Sig_hat = (Sig_hat+Sig_hat')/2;
    var_explode = 1;
    while (var_explode ~= 0)
        %SIGu = Sig_hat*nobsc/(nobsc-k-nvar);
        SIGu = iwishrnd(Sig_hat*nobsc,nobsc-k);
        S = kron(SIGu,invxxxxc/nobsc);
        PHIu=zeros(size(PHI));
        PHIu(:) = mvnrnd(PHI(:),(S+S')/2);

        if nlags > 1
           eye(nvar*nlags);
           B = [ PHIu(1+nconst+ncoint:end,:)'; ans(1:nvar*(nlags-1),:) ];
        else
           B = PHIu(1+nconst+ncoint:end,:)';
        end

        var_explode = sum(abs(eig(B))>1);
        if var_explode > 0
           warning('VAR Explosive')
           count_explode = count_explode + 1;
        end
    end
    Sig   = chol(SIGu,'lower');

    STD_EPSG     = Theta(end-7);
    STD_EPSMUZ   = Theta(end-6);
    STD_EPSMUUPS = Theta(end-5);
    STD_EPSD     = Theta(end-4);
    STD_EPSP     = Theta(end-3);
    STD_EPSW     = Theta(end-2);
    STD_EPSR     = Theta(end-1);
    STD_EPStau   = Theta(end);

    shocks = zeros(nvar,nvar);
    shocks(1,1) = STD_EPSG;     
    shocks(2,2) = STD_EPStau;   
    shocks(3,3) = STD_EPSMUZ;   
    shocks(4,4) = STD_EPSMUUPS; 
    shocks(5,5) = STD_EPSD;     
    shocks(6,6) = STD_EPSW;     
    shocks(7,7) = STD_EPSP;     
    shocks(8,8) = STD_EPSR;     

    A0          = MM(:,vectr)*shocks;%
    [q r]       = qr(A0');
    Sigstar     = r';
    Omegastar   = q';
    %% Normalize matrices (change row signs) so that the 
    %%lower diagonal matrix Sigstar has positive diagonal elements  
    Sigstar   = repmat(sign(diag(r)),[1 nvar]).*Sigstar;
    Omegastar = repmat(sign(diag(r)),[1 nvar]).*Omegastar;

    IRFid = Sig*Omegastar;

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % cc_dy   = eye(nvar*nlags);
    % cc_y    = eye(nvar*nlags);
    % msel    = [eye(nvar) ; zeros((nlags-1)*nvar,nvar)];
    % %bbirf    = zeros(IRFtime,nvar^2);
    % bbirf    = zeros(IRFtime,nvar,nvar);
    % out         = msel'*cc_dy*msel*IRFid;
    % %bbirf(1,:)  = out(:)';
    % bbirf(1,:,:)  = out;
    % 
    % for t = 2:IRFtime;                 
    %   cc_dy = B*cc_dy;
    % %   if coint
    % %     cc_dy = cc_dy+(cc_cointtilde*cointvec*msel')*cc_y;
    % %     cc_y  = cc_y + cc_dy;
    % %   end
    %   out = msel'*cc_dy*msel*IRFid;
    %  % bbirf(t,:)    = out(:)';  
    %   bbirf(t,:,:)    = out;  
    % end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for k = 1:1%nvar    
        shock = zeros(nvar,1);
        shock(k)= 1;
        IR = zeros(IRFtime,nvar);
        for j = 1 : IRFtime
             B^(j-1);
             IR(j,:) = ans(1:nvar,1:nvar)*IRFid*shock;
             IRu(j,:) = ans(1:nvar,1:nvar)*Sig*shock;
        end
        IRF_i = IR;
        IRF_i(:,[3,4,6]) = cumsum(IRF_i(:,[3,4,6])); 
        RESPONSES(:,:,k) = IRF_i; 
        
        IRF_i = IRu;
        IRF_i(:,[3,4,6]) = cumsum(IRF_i(:,[3,4,6])); 
        RESPONSESu(:,:,k) = IRF_i; 

        IR = zeros(IRFtime,sizex);
        x0 = zeros(sizex,1);
        x0(vectr(k)) = shocks(k,k);
        for j = 1:IRFtime
            IR(j,:) = x0';
            x0 = hx*x0;
        end
        IRFgrowth(:,:,k) = IR*gxz';
    end
    IRFvar(:,:,:,b)  = RESPONSES;
    IRFth(:,:,:,b)   = IRFgrowth; 
    IRFtvar(:,:,:,b) = RESPONSESu;
end

for l = 1:IRFtime
    for j = 1:nvar
        IRFv(l,j,1:3) = prctile(squeeze(IRFvar(l,j,1,:)),[5 50 95]);
        IRFt(l,j,1:3) = prctile(squeeze(IRFth(l,j,1, :)),[5 50 95]);
        IRFu(l,j,1:3) = prctile(squeeze(IRFtvar(l,j,1, :)),[5 50 95]);
    end
end

names_shocks = {'G';'Tax';'Tech';'Inv';'d';'W';'p';'Money'};
h = figure;
k  = 1;
%for k = 1:nvar
    for i = 1:nvar
       subplot(4,2, (k-1)*nvar + i)
       X=[[1:1:IRFtime],fliplr([1:1:IRFtime])];                
       Y=[100*IRFv(:,i,1)',fliplr(100*IRFv(:,i,3)')];            
       fill(X,Y,'b','FaceColor',[0.8 0.8 0.8],...
       'EdgeColor','k'); %#plot filled area
       hold on
       plot([1:1:IRFtime],100*IRFv(:,i,2),'LineWidth',2,'Color',[0 0 0]);
       hold on
       Y=[100*IRFt(:,i,1)',fliplr(100*IRFt(:,i,3)')]; %#create y values for out and then back
       fill(X,Y,'b','LineStyle','--',...
       'FaceColor',[0.960784316062927 0.921568632125854 0.921568632125854],'FaceAlpha', 0.5,...
        'EdgeColor',[0 0.447058823529412 0.741176470588235]); %#plot filled area
       hold on
       plot([1:1:IRFtime],100*IRFt(:,i,2),'LineWidth',1,'Color',[0 0.447058826684952 0.74117648601532]);
       axis tight
       title(names(i,:))
    end
%end
%suptitle('Estimated responses and model responses ')
print(h,'-dps','est_IRFS_PROD.eps')
print(h,'-dpdf','est_IRFS_PROD.pdf')

RESPONSESu = IRF_i; 
h = figure;
for i = 1:nvar
   subplot(4,2, (k-1)*nvar + i)
   X=[[1:1:IRFtime],fliplr([1:1:IRFtime])];                
   Y=[100*IRFu(:,i,1)',fliplr(100*IRFu(:,i,3)')];            
   fill(X,Y,'b','FaceColor',[0.8 0.8 0.8],...
   'EdgeColor','k');                  %#plot filled area
   hold on
   plot([1:1:IRFtime],100*IRFu(:,i,2),'LineWidth',2,'Color',[0 0 0 ]);
   axis tight
   title(names(i,:))
end
%suptitle('Cholesky implied IRFs')
print(h,'-dps','Chol_est_IRFS_PROD.eps')
print(h,'-dpdf','Chol_est_IRFS_PROD.pdf')

save res_PROD.mat