%function [RHOupsP, RHOupsW, UPSP, UPSW, MUw, MUp, QQ, SHAREGC, DELTAG, GK, GC, GIV, EPSW, EPSP, RHOp, RHOw, TAU, EPSTAU, RHOtau, ALFA_tau, ALFA_tauy, EPSG, ZZETA, ALFAG, LA, RHOPREF, RHOG, RHOMUZ, RHOMUUPS, RHOR, PSSI, BETTA, THETA, DELTA, HB, KAPA, GAMAI, GAMAII, ETA, ETATIL, ALFA, ALFATIL, ALFA_R, ALFA_PAI, ALFA_Y, SSIGMA, R, D, G, MUZ, MUUPS, H, K, OUTPUT, C, PAI, U, MUTIL, W, IV, MUZSTAR, MC, MUR] = steady_state(x);
%function steady_state(x);

RHOupsP  = 0;
RHOupsW  = 0;
UPSP     = 1;
UPSW     = 1;

RHOtau   = 0;
QQ       = 1;
TAU      = 0.18;
EPSTAU   = 1;
%EPSG     = 0.2;
MUR      = 1;
EPSP     = 1;
EPSW     = 1;
ETA      = 6;
ETATIL   = 21;
U        = 1;
PAI      = 1.0086;%1.042^(1/4); %Inflation
BETTA    = 0.999;
THETA    = 0.3;%0.36; %Capital share; I use a much smaller capital share to avoid the problem of getting an investment share of over 1/3 of GDP.
DELTA    = 0.025; 
MUZSTAR  = 1.0047; % steady state growth rate of output is 0.0047
MUUPS    = 1.0042; % ACEL
D        = 1;
RHOR     = 0;
SHAREG   = 0.2; % Share of gov't expenditures in gdp 
SHAREGC  = 0.8; 
DELTAG   = DELTA;
EPSG = SHAREG*MUZSTAR;

HB       = x(1);% 0.7;
ALFAG    = x(2);
ALFA     = x(3);% 20
ALFATIL  = x(4);% 20
ALFA_R   = x(5);%0.5;
ALFA_PAI = x(6);%1;
ALFA_Y   = x(7);%0.2;
KAPA     = x(8);%3;
GAMAII_GAMAI = x(9);%2;% FIX IT   %0.01;
SSIGMA    = x(10);
ALFA_tau = x(11);
ALFA_tauy= x(12);

RHOG     = x(13);% 0.5;
RHOMUZ   = x(14);% 0.5;
RHOMUUPS = x(15);% 0.5;
RHOPREF  = x(16);% 0.5;
RHOp     = x(17);
RHOw     = x(18);
MUp      = x(19);
MUw      = x(20);

MUZ      = MUZSTAR/ MUUPS^(THETA/(1-THETA));
MUI      = MUUPS * MUZSTAR; 
R        = PAI / BETTA *MUZSTAR; %Nominal interest rate
RK       = (MUI/BETTA -1 + DELTA)/(1-TAU);
MUTIL    = ETATIL / (ETATIL-1)/(1-TAU);
MC       = (ETA - 1)/ETA;% Marginal cost of producing a unit of final good

K_OUTPUT  = THETA*MUI/U/RK; %RK/THETA/MC*MUI/U;%THETA*MC*MUI/U/RK;
I_OUTPUT  = (1-(1-DELTA)/MUI) * K_OUTPUT;
C_OUTPUT  = 1-SHAREG-I_OUTPUT;

H = 0.5;
OUTPUT    = (MC*(K_OUTPUT*U/H/MUI)^THETA*H*((1-SHAREGC)*SHAREG/(1-(1-DELTAG)/MUZSTAR))^(ALFAG))^(1/(1-THETA-ALFAG));

K    = K_OUTPUT*OUTPUT;
IV   = I_OUTPUT*OUTPUT;
C    = C_OUTPUT*OUTPUT;
G    = SHAREG*OUTPUT;
W    = (1-THETA)*OUTPUT/H;%MC*(U*K/MUI/H)^(THETA)*G^(ALFAG); %OUTPUT/H;

GC   = SHAREGC*G;
GIV  = G-GC;
GK   = GIV/(1-(1-DELTAG)/MUZSTAR);

%ZZETA = - 1 + H*(1-HB*BETTA/MUZSTAR)*W/MUTIL*(SSIGMA-1)/C/(1- HB/MUZSTAR);
%LA       = D * ( C*(1-HB/MUZSTAR))^(-SSIGMA) * H^(ZZETA+1)*(1-HB*BETTA/MUZSTAR); %!!!!

ZZETA  = (1-TAU)*(1 - BETTA*HB/MUZSTAR)*W/MUTIL*(1 - H)*(1-SSIGMA)/(C - C*HB/MUZSTAR) ;
LA     = D*(1 - H)^ZZETA /(C - C*HB/MUZSTAR)^SSIGMA*(1 - BETTA*HB/MUZSTAR);

PSSI   = (1-MC)*(U*K/MUI)^THETA* H^(1-THETA)*(GK)^ALFAG;

GAMAI  =(1-TAU)* RK/QQ;
GAMAII = GAMAII_GAMAI*GAMAI;

BETTA  = BETTA/MUZSTAR^(1-SSIGMA);

MUC  = MUZSTAR; 
MUIV = MUI;
MUW  = MUZSTAR; 