% ROT model
clear all
clc
close all

datapath  = 'C:\Users\31049308\Dropbox\Research\Government_Spending\data\';

restoredefaultpath
currentpath = pwd;
model = 'ROT';
pathname = [currentpath(1:end-length(model))];
eval(['addpath ',pathname,'MODEL'])

[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;

global nvar nobs T0 coint nlags nconst
nvar = 8;
nobs = 221; nlags = 4;
nconst = 0; coint = 0; ncoint = 0;T0 = nlags;

[series data] = loaddata(datapath);
for i = 1:size(data,2)
    data(:,i) = data(:,i) - mean(data(:,i));
end

format long g

%           HB      ALFA   ALFATIL  ALFA_R, ALFA_PAI, ALFA_Y, KAPA  A''/A'  SIGMA    TAU       TAUy     RHOG    RHOMUZ RHOMUUPS RHOPREF RHOP    RHOW    MUP     MUW   STD_G   STD_MUZ STD_MUUPS STD_D  STDP       STDW STDTAU STDR \\          
%            1       2        3       4        5      6        7      8        9       10       11       12       13      14     15      16      17      18      19        20      21     22       23     24      25      26      27       28     29\\
%Theta = [0.5D+0, 20.0D+0, 100.0D+0,  0.7D+0, 1.0D+0, 0.2D+0, 3.0D+0, 2.0D+0 , 3.0D+0, 0.85D+0, 0.01D+0, 0.5D+0, 0.5D+0, 0.5D+0, 0.5D+0, 0.5D+0, 0.5D+0, 0.9D+0, 0.9D+0, 0.1D+0, 0.1D+0, 0.1D+0,  0.1D+0, 0.1D+0, 0.1D+0, 0.1D+0, 0.1D+0];
Theta = [ 0.5    20       100        0.70    0.50    0.100   1.0     2.00     2.00     0.850   0.01     0.900   0.5     0.5     0.500   0.5     0.50    0.80    0.80    0.1     0.1     0.100    0.100   0.10    0.10    0.10    0.10];

% CALCULATE AND PLOT LIKELIHOOD PROFILES IF NEEDED
if ( 1 == 2)
    grid_size = 20
    %!        1       2     3      4        5       6       7      8      9       10      11     12     13     14     15       16        17      18     19
    %!        HB     ALFA ALFATIL RHOMUZ RHOMUUPS  RHOG   RHOPREF STDG  STDMUZ STDMUUPS STDPREF  STDR    MU    GAMA   ALFA_R, ALFA_PAI, ALFA_Y, KAPA, A''/A'
    xmin = [ 0.01,   10.0, 10.0,   0.01,   0.1,   0.01,   0.01,  0.05,   0.02,   0.01,  0.02,  0.002,  0.4,   0.01,  0.7,   0.2, 0.01,   1.0,  2 ];
    xmax = [ 0.999   150   200    0.999   0.999   0.6    0.6      0.3     0.3    0.1      0.3   0.02    1.5   0.7   1      3    0.1    5   20 ];

    x_i(1,:) = xmin;
    step_i   = (xmax-xmin)/(grid_size+1)
    x_i(1,:) = xmin;
    for i = 1 : grid_size - 1
         x_i(i+1,:) = x_i(i,:)  + step_i;
    end

    for i = 1: length(step_i)
    
        Theta_i = Theta;
        for j = 1:size(x_i,1)
            Theta_i(i) = x_i(j,i);
            % evaluating the first likelihood and prior functions
            [loglike(j,i), exitflag] = kalman(Theta_i,data,f, fx, fy, fxp, fyp, statevar_cu,controlvar_cu,statevar_cup,controlvar_cup);
            logpri = priordeephabits(Theta_i);
            loglikelogpri(j,i) = loglike(j,i) + logpri;
        end
    end
    names = char( '         b             ',...
                  '    \alpha_p           ',...
                  '    \alpha_w           ',...
                  '    \rho_{\mu_{z}}     ',...
                  ' \rho_{\mu_{\upsilon}} ',...
                  '       \rho_{gg}       ',...
                  '       \rho_{d}        ',...
                  '       \sigma_{g}      ',...
                  '     \sigma_{\mu_z}    ',...
                  '\sigma_{\mu_{\upsilon}}',...
                  '       \sigma_{d}      ',...
                  '       \sigma_{\mu_r}  ',... 
                  '          \mu          ',...
                  '       \gamma          ',...
                  '       \alpha_R        ',...
                  '       \alpha_{\pi}    ',...
                  '       \alpha_Y        ',...
                  '       \kappa          ',...
                  ' \delta_2/\delta_1     ');

    figure
    for i = 1 : length(step_i)
        subplot(4,5,i)
        plot(x_i(:,i),loglike(:,i))
        title(['\fontsize{16} \bf ' names(i,:)])
        axis tight
    end

       figure
    for i = 1 : length(step_i)
        subplot(4,5,i)
        plot(x_i(:,i),loglikelogpri(:,i))
        title(['\fontsize{16} \bf ' names(i,:)])
        axis tight
    end
end


%load mean_est.txt

Theta = mean_est;
[loglike, exitflag] = kalman(Theta,data,f, fx, fy, fxp, fyp, statevar_cu,controlvar_cu,statevar_cup,controlvar_cup)
%close all

return
logpri = priordeephabits(Theta);
loglikelogpri = loglike + logpri;

acc   = 0;
count = 0;

hessian = 1;
if hessian == 1 
     hessian_x     = fn_hesscd(Theta,1.e-05,data,f, fx, fy, fxp, fyp, statevar_cu,controlvar_cu,statevar_cup,controlvar_cup);
     H0            = -inv(hessian_x);
     [V,D]         = eig(H0);
     D             = abs(D);
     H0            = V*D*V';
     D             = chol(H0);
else
      D = 1;
end

sig_th = 0.03*ones(size(Theta));
tic;
Niter = 1000000;
for j = 1:Niter
    j
    if rem(j,10000) == 0  
       [ j  loglike acc ]
       Theta
    end
    exitflag = 0;
    while exitflag ~= 1
        newTheta  = Theta + (sig_th .* randn(size(Theta)))*D;
        newlogpri = priordeephabits(newTheta);
        while newlogpri == -inf 
            newTheta  = Theta + (sig_th.*randn(size(Theta)))*D;%mvnrnd(zeros(1,length(Theta)), variance_normal); 
            newlogpri = priordeephabits(newTheta);
        end
        [newloglike, exitflag] = kalman(newTheta,data,f, fx, fy, fxp, fyp,statevar_cu,controlvar_cu,statevar_cup,controlvar_cup);
    end
        if newloglike==-Inf;
                ratio=0;
        else
                ratio = exp(newloglike + newlogpri - (loglike + logpri));
                count = count + 1;
                if rand <= ratio % we accept with prob ratio
                        loglike = newloglike;
                        logpri  = newlogpri;
                        Theta   = newTheta;
                        acc     = acc + 1; % keeping track of the acceptances
                end
        end
        Theta_s(j,:)   = Theta;
        loglike_s(j,1) = loglike;
        logpri_s(j,1)  = logpri;
end
Theta           = mean(Theta_s,1);
acceptance_rate = acc/Niter*100;

toc;
hours=toc/3600;