%function [RHOupsP, RHOupsW, UPSP, UPSW, MUw, MUp,  QQ, EPSG, EPSP, EPSW, RHOp, RHOw, TAU, EPSTAU, RHOtau, ALFA_tau, ALFA_tauy, ZZETA, TC, TU, LAMBDA, RHOPREF, RHOG, RHOMUZ, RHOMUUPS, RHOR, PSSI, BETTA, THETA, DELTA, HB, KAPA, GAMAI, GAMAII, ETA, ETATIL, ALFA, ALFATIL, ALFA_R, ALFA_PAI, ALFA_Y, SSIGMA, R, D, G, MUZ, MUUPS, B, H, K, OUTPUT, C, CU, PAI, U, MUTIL, W, IV, MUZSTAR, LA] = steady_state(x);

TAU      = 0.18;
RHOtau   = 0;

RHOupsP  = 0;
RHOupsW  = 0;
UPSP     = 1;
UPSW     = 1;
EPSTAU   = 1;
EPSP     = 1;
EPSW     = 1;

QQ       = 1;
MUR      = 1;
ETA      = 6;
ETATIL   = 21;

U        = 1;
PAI      = 1.0086;%1.042^(1/4); %Inflation
BETTA    = 0.999;%1.03^(-1/4); %Discount factor;
THETA    = 0.3; % 0.36; %Capital share; I use a much smaller capital share to avoid the problem of getting an investment share of over 1/3 of GDP.
DELTA    = 0.025; 
MUZSTAR  = 1.0047; % steady state growth rate of output is 0.0047
MUUPS    = 1.0042; % ACEL
D        = 1;
RHOR     = 0.0;%x(11); 
SHAREG   = 0.2; % Share of gov't expenditures in gdp 
EPSG     = SHAREG*MUZSTAR;

LAMBDA   = x(1);% 0.5;
HB       = x(2);% 0.7;

ALFA     = x(3);% 20
ALFATIL  = x(4);% 20
ALFA_R   = x(5);%0.5;
ALFA_PAI = x(6);%1;
ALFA_Y   = x(7);%0.2;
KAPA     = x(8);%3;
GAMAII_GAMAI = x(9);%2
SSIGMA    = x(10);%1.01;%x(23);
ALFA_tau =  x(11);
ALFA_tauy=  x(12);

RHOG     = x(13);% 0.2;
RHOMUZ   = x(14);% 0.8;
RHOMUUPS = x(15);% 0.8;
RHOPREF  = x(16);% 0.8;
RHOp     = x(17);
RHOw     = x(18);
MUp      = x(19);
MUw      = x(20);

MUZ      = MUZSTAR/ MUUPS^(THETA/(1-THETA));
MUI      = MUUPS * MUZSTAR; 
R        = MUZSTAR* PAI / BETTA; %Nominal interest rate
RK       = (MUI/BETTA -1 + DELTA)/(1-TAU); % Rental rate of capital
MUTIL    = ETATIL / (ETATIL-1)/(1-TAU);
MC       = (ETA - 1)/ETA;% Marginal cost of producing a unit of final good

K_H      = MUI/U*(RK/MC/THETA)^(1/(THETA-1)); % Aggregate capital factor input
IV_H     = (1-(1-DELTA)/MUI) * K_H; % investment
W        = MC * (1-THETA) * (U*K_H/MUI)^THETA; % Average real wage rate
OUTPUT_H = MC*(U*K_H/MUI)^THETA ; % Aggregate absorption
PSSI_H   = (1-MC)*(U*K_H/MUI)^THETA;
G_H      = SHAREG * OUTPUT_H;  % Government spending
C_H      = OUTPUT_H - IV_H - G_H ; % Private consumption

%H        = ((W*(1-BETTA*HB/MUZSTAR))/C_H/MUTIL/(1-HB/MUZSTAR) )^(1/(1+ZZETA));
H    = 0.5;
%ZZETA = - 1 + (1-HB*BETTA/MUZSTAR)*W/MUTIL*(SSIGMA-1)/C_H/(1- HB/MUZSTAR);

C        = C_H*H;
XX       = C*(1- HB/MUZSTAR);
G        = G_H * H;
IV       = IV_H*H;
K        = K_H*H;
OUTPUT   = OUTPUT_H * H ;
PSSI     = PSSI_H*H;
TC       = (W*H*(1-TAU) - C);
CC       = C;
CU       = C;
%DIV      = (1-MC)*K^THETA*H^(1-THETA);
% TU       = W*H + DIV - CU ;
% T        = LAMBDA*TC + (1-LAMBDA)*TU; 
% B        = (G-T)/(1/R-1/PAI/MUZSTAR);
B        = 0;
T        = G;% - B*(1/R-1/PAI/MUZSTAR);
TU       = (T - TC*LAMBDA)/(1-LAMBDA);
%LA        = D * ((C-HB*C/MUZSTAR)-H^(ZZETA+1)/(ZZETA+1)*XX)^(-SSIGMA)*(1-HB*BETTA/MUZSTAR); %!!!!
%LA       = D * ( C*(1-HB/MUZSTAR))^(-SSIGMA) * H^(ZZETA+1)*(1-HB*BETTA/MUZSTAR); %!!!!

ZZETA = (1 - BETTA*HB/MUZSTAR )*(1-TAU)*W/MUTIL*(1-SSIGMA)*(1-H)/(CU - (CU*HB)/MUZSTAR) ;
LA = D*(1 - H)^ZZETA/(CU - CU*HB/MUZSTAR)^SSIGMA *(1 - BETTA*HB/MUZSTAR );
LAC = LA;

GAMAI    = (1-TAU)*RK/QQ;
GAMAII    = GAMAII_GAMAI*GAMAI;
BETTA    = BETTA/MUZSTAR^(1-SSIGMA);

MUC  = MUZSTAR; 
MUIV = MUI;
MUW  = MUZSTAR; 