%% This file contains the specification of the VAR model
function [] = varspec();
global nblocks nsim  nburn
global mprior dates nvar nlags T0 Tend npara lambdaseq para_names bounds para varnames cum_for 
%global polipar polivalue 
global cum_irf names_shocks fixparamseq coint cointadd cointall cointvec cointaddvec ncoint
global stime st qahead para_mask para_fix
global pshape
global Pmean Pstd DTheta Lo Up nobs nconst


nconst = 0;
nobs = 221;
%% choose prior
mprior = 1; %% 1 is standard

%% Effective sample size to generate prior 
lambdaseq = [0 ceil(100*((7*4+3+1)+7)/120)/100 .5 .75 1 1.25 1.5 2 5 Inf NaN];%[0 ceil(100*((7*4+3+1)+7)/120)/100 .5 .75 1 1.25 1.5 2 5 Inf NaN];

%% coint = 0 : just growth rates, otherwise number of cointegrating relationships
%% model 1: coint = 4
%% model 2: coint = 0
%% model 101,102,103,104,105,106,107,108,109,110,111,112,113: coint = 3
coint = 0;%3;
cointadd = 0;
cointall = coint + cointadd;
ncoint = 0;


%% number of lags
nlags = 4;

%% choose date
dates = 2004.00;
   
%% number of observations used in VAR (st = [] means use entire sample) 
%stime = 120; 
%st    = num2str(stime);
    
%% End of Presample
T0 = nlags; 
Tend     = 0;        % End of Estimation Sample 

%% fixparamseq = 1 exogenous (fixed parameters) at para
fixparamseq = [0];
%% if JustMode: do not do simulations and compute forecasts at mode
%JustMode = 0;           
% quarters ahead for computing forecasts
%qahead   = 16;                                     

%%  Configure the Metropolis Algorithm (number of simulations)
nblocks  = 1;
nsim     = 100;
nburn    = 0;%nsim; % initial simulations to 'burn'

nvar = 8;
%varnames = {'I';'C';'Inflation';'W';'H';'G/Y';'R';'TR/Y'};
%cum_for = [  1   1   0           1   0    0    0  0];

% if coint 
%       cointvec = zeros(coint,nvar);
%       %% C - Y
%       cointvec(1,1) = -1;
%       cointvec(1,2) = 1;
%       %% I - Y
%       cointvec(2,1) = -1;
%       cointvec(2,3) = 1;
%       %% W - Y
%       cointvec(3,1) = -1;
%       cointvec(3,5) = 1;
% else
%       cointvec = [];
% end
% cointaddvec = zeros(cointadd,nvar);
% if cointadd > 0
%       %% Y
%       cointaddvec(1,1) = 1;
% else
%       cointaddvec = [];	
% end;

%% names of shocks, and variables for which we want cumulative irf
cum_irf = [1 2 3 5];
names_shocks = {'Tech';'\phi';'\chi';'\mu';'b';'g';'\lambda_f';'Money'};    
% 
% para_names = {'b';'\alpha';'\tilde \alpha';'\alpha_R';'\alpha_{pi}';'\alpha_Y';'\kappa';'GII/GI';...
%     '\sigma';'\alpha_{\tau}';'\alpha_{\tau,y}';'\rho_g';'\rho_{z}';'\rho_{\upsilon}';'\rho_{pref}';...
%     '\rho_p';'\rho_w';'\mu_p';'\mu_w';'\sigma_g';'\sigma_{z}';'\sigma_{\upsilon}';'\sigma_{pref}';...
%     '\sigma_p';'\sigma_w'; '\sigma_R';'\sigma_{\tau}'};

%% starting values for parameters
npara = 28;
para = zeros(npara,1);

%% para_mask is npara x 1
%%   to fix a parameter under specification mspec, set the corresponding element of para_mask to 1
%% para_fix is npara x 1
%%   and contains the values for the fixed parameters (all other entries are irrelevant)
para_mask = zeros(npara,1);
para_fix  = zeros(npara,1);

%         LAMBDA   HB  ALFAp  ALFAw A_R, A_PI,  A_Y,  KAPA,  A''/A' SIG    A_T  A_TY  RHOG   RHOZ RHOUPS RHOD RHOP RHOW  MUP  MUW  S_G  S_Z S_UPS S_D  S_P  S_W  S_R  S_T %   
%            1      2      3     4   5      6      7    8       9     10    11     12    13   14     15   16   17    18   19   20   21   22   23   24   25   26   27%
Pmean   = [  0.2,   0.5,   20,   100,  0.7, 0.5,   0.1,   1.0,  2.0,   2.0,  0.85,  0.01,  0.9,  0.5,  0.5,  0.5,  0.5, 0.5, 0.8, 0.8, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1]';
Pstd    = [ 0.05,   0.2,    5,    30,  0.2, 0.2,  0.05,   0.5,  0.5,   0.5,   0.1,   0.1, 0.05,  0.2,  0.2,  0.2,  0.2, 0.2, 0.1, 0.1, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0]';
DTheta  = [  'B',   'B',  'G',   'G',  'B', 'G',   'G',   'G',  'G',   'G',   'B',   'I',  'B',  'B',  'B',  'B',  'B', 'B', 'B', 'B', 'U', 'U', 'U', 'U', 'U', 'U', 'U', 'U']';
Lo      = [    0,     0,    0,     0,    0,   0,     0,     0,    0,     0,     0,     0,    0,    0,    0,    0,    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  0 ]';
Up      = [    1,     1, 1000,  1000,    1, 1000, 1000,  1000, 1000,   100,     1,   100,    1,    1,    1,    1,    1,   1,1000,1000,1000,1000,1000,1000,1000,1000,1000,1000]';

para = Pmean;
bounds(:,1) = Lo;
bounds(:,2) = Up;

%    para(18) = .8;          %para_mask(18) = 1; para_fix(18) = para(18);            %% rho_r;       18
para = para.*(1-para_mask)+para_fix.*para_mask;
%% identify policy and non policy parameters
% polipar = [16];
% polivalue = [2];

for i  = 1:npara
    if DTheta(i) == 'B'
        pshape(i,1) = 1;
    elseif DTheta(i) == 'G'
        pshape(i,1) = 2;
    elseif DTheta(i) == 'I'
        pshape(i,1) = 4;
    elseif DTheta(i) == 'N'
        pshape(i,1) = 3;
    elseif DTheta(i) == 'U'
        pshape(i,1) = 0;
    end
end