clear all
clc
close all

global nvar ncoint
global para_mask para_fix
global nobs lambda
global Pmean Pstd pshape

restoredefaultpath

currentpath = pwd;
model = 'UTIL';
eval(['addpath ', currentpath(1:end-length(model)), 'MODEL'])

datapath  = 'C:\Users\anutako\Dropbox\Research\Government_Spending\data\';

rand('state',sum(100*clock))
varspec();
VECM = 0 ;
format long g
if (1 == 1)
    [series,YY,XX,ti] = loaddata(datapath);
    if (VECM == 0)
        XX = XX(:,ncoint+1:end);
    end
    YY = YY - kron(mean(YY),ones(length(YY),1));%kron(mean(YY),[1;1])
    XX = XX - kron(mean(XX),ones(length(XX),1));
    YYYY = YY'*YY;
    XXYY = XX'*YY;
    XXXX = XX'*XX;

    pshape = pshape.*(1-para_mask); % either distr or 0
    Pmean  = Pmean.*( 1-para_mask) + para_fix.*para_mask;% either pmean or fixes value
    Pstd   = Pstd.*( 1-para_mask); % either pstdd or zero

    fid = fopen('mXXXX_dm0.txt','w');
    for i = 1:size(XXXX,1)
        for j = 1:size(XXXX,1)
            fprintf(fid,[ num2str(XXXX(j,i),'%10.16f') , '\r\n']);
        end
    end
    fclose(fid);

    fid = fopen('mYYYY_dm0.txt','w');
    for i = 1:nvar
        for j = 1:nvar
            fprintf(fid,[ num2str(YYYY(j,i),'%10.16f') , '\r\n']);
        end
    end
    fclose(fid);

    fid = fopen('mXXYY_dm0.txt','w');
    for i = 1:nvar
        for j = 1:size(XXXX,1)
            fprintf(fid,[ num2str(XXYY(j,i),'%10.16f') , '\r\n']);
        end
    end
    fclose(fid);
end

% load mXXYY_dm0.txt
% load mXXXX_dm0.txt
% load mYYYY_dm0.txt
% 
% XXXX = reshape(mXXXX_dm0,nconst+ncoint+nvar*nlags,nconst+ncoint+nvar*nlags);
% XXYY = reshape(mXXYY_dm0,nconst+ncoint+nvar*nlags,nvar);
% YYYY = reshape(mYYYY_dm0,nvar,nvar);
% clear mXXXX_dm0
% clear mXXYY_dm0
% clear mYYYY_dm0

nobs = 221;%size(YY,1);
lambdas  = 0.4;%33;
lambda = lambdas*nobs;

%Theta = [0.5       0.5       0.5  0.5  20 100  0.7       0.5       0.1   1.        2.        2.  0.85       1.0E-002  0.9  0.5       0.5       0.5  0.5       0.5       0.8  0.8       0.1       0.1   0.1       0.1       0.1   0.1       0.1       0.1];

%load C:\Users\31049308\Dropbox\Research\Government_Spending\RR_JMCB\GOVSP_2015_0609_files\GOVSP_2015_0609_files\fortran\results_DSGEVAR\2015_0602\UTIL\LA04\mean_est.txt
load C:\Users\anutako\Dropbox\Research\GSP3\DSGEVAR\UTIL\mean_est.txt
Theta = mean_est;

[f, fx, fy, fxp, fyp, statevar_cu,statevar_cup,controlvar_cu,controlvar_cup] = competitive_eqm;
loglike = objfcnmh(Theta,YYYY,XXYY,XXXX,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu)
return
%acc   = 0;
%count = 0;
% hessian = 1;
% if hessian == 1 
%      hessian_x     = fn_hesscd(Theta,1.e-05,YYYY,XXYY,XXXX,f, fx, fy, fxp, fyp, statevar_cu,controlvar_cu);
%      H0            = -inv(hessian_x);
%      [V,D]         = eig(H0);
%      D             = abs(D);
%      H0            = V*D*V';
%      D             = chol(H0);
% else
%       D = 1;
% end
% save hess.mat D 
% return

%load hess.mat D

load res_BL.mat y xDist_BL
format short g
sig_th = 0.03;
tic;
Niter = 30001;
% y(Niter,:) =  [0.938571972952732        57.0182932346793        350.680936870954 ...
%   1.645509491940614E-002   1.82206079660087       4.978945257321703E-002 ...
%    10.6895129927561        15.1102927428805       0.489436584957103 ...
%   0.965016385732844       8.954329288972272E-003  0.956143387617715 ...
%   0.821687246816348       0.999999775447929       0.125727604548048 ...
%   0.946017742033782       0.985285728854150       0.720099867816664 ...
%   0.913701006182450       1.457174755081226E-002  9.167643764372574E-003 ...
%   1.190060319439070E-002  0.135105815945987       0.138673586778599 ...
%    2.73873361510850       0.227809739191271       2.567483872313897E-002];
for j = 1:100:Niter
%     if rem(j,10000) == 0  
%        [ j  loglike acc ]
%        Theta
%     end
%     exitflag = 0;
%     while exitflag ~= 1
%         newTheta  = Theta + (sig_th*randn(size(Theta)))*D;
%         newlogpri = priordeephabits(newTheta);
%         while newlogpri == -inf 
%             newTheta  = Theta + (sig_th*randn(size(Theta)))*D;%mvnrnd(zeros(1,length(Theta)), variance_normal); 
%            newlogpri = priordeephabits(newTheta);
%        end
%        %[newloglike, exitflag] = kalman(newTheta,data,f, fx, fy, fxp, fyp,statevar_cu,controlvar_cu,statevar_cup,controlvar_cup);
%         newloglike = objfcnmh(newTheta,YYYY,XXYY,XXXX,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);
%    end
     
    newloglike(j) = objfcnmh(y(j,:),YYYY,XXYY,XXXX,f,fx, fy, fxp, fyp,statevar_cu,controlvar_cu);
    [ j newloglike(j) xDist_BL(j) ]
%     if newloglike == -Inf;
%                 ratio = 0;
%         else
%                 ratio = exp(newloglike + newlogpri - (loglike + logpri));
%                 count = count + 1;
%                 if rand <= ratio % we accept with prob ratio
%                         loglike = newloglike;
%                         logpri  = newlogpri;
%                         Theta   = newTheta;
%                         acc     = acc + 1; % keeping track of the acceptances
%                 end
%         end
%         Theta_s(j,:)   = Theta;
%         loglike_s(j,1) = loglike;
%         logpri_s(j,1)  = logpri;
end
return
Theta           = mean(Theta_s,1);
acceptance_rate = acc/Niter*100;

toc
hours=toc/3600