%function [RHOupsP, RHOupsW, UPSP, UPSW, MUw, MUp,  TAU, EPSTAU, ALFA_tau, ALFA_tauy, RHOtau, RHOw, RHOp, EPSG, QQ, EPSP, EPSW, ZZETA, PHI, MUU, LA, RHOPREF, RHOG, RHOMUZ, RHOMUUPS, RHOR, PSSI, BETTA, THETA, DELTA, HB, KAPA, GAMAI, GAMAII, ETA, ETATIL, ALFA, ALFATIL, ALFA_R, ALFA_PAI, ALFA_Y, SSIGMA, R, D, G, MUZ, MUUPS, H, K, OUTPUT, C, PAI, U, MUTIL, W, IV, MUZSTAR, MC, MUR] = steady_state(x);

TAU      = 0.18;
RHOtau   =  0;
EPSTAU   = 1;
RHOupsP  = 0;
RHOupsW  = 0;
UPSP     = 1;
UPSW     = 1;

EPSG     = 0.2;
QQ       = 1;
EPSP     = 1;
EPSW     = 1;

MUR      = 1;
ETA      = 6;
ETATIL   = 21;
U        = 1;
PAI      = 1.0086;%1.042^(1/4); %Inflation
BETTA    = 0.999;
THETA    = 0.3;%0.36; %Capital share; I use a much smaller capital share to avoid the problem of getting an investment share of over 1/3 of GDP.
DELTA    = 0.025; 
MUZSTAR  = 1.0047; % steady state growth rate of output is 0.0047
MUUPS    = 1.0042; % ACEL
D        = 1;
RHOR     = 0;
SHAREG   = 0.2; % Share of gov't expenditures in gdp 
EPSG     = SHAREG*MUZSTAR;

HB       = x(1);% 0.7;
MUU      = x(2);%0.5; %Elasticity of subsitution between public and private consumption                                                                                                                                                                                              
PHI      = x(3);%x(14);%0.5;  % Weight on private consumption relative to publicconsumption in determining effective consumption

ALFA     = x(4);% 20
ALFATIL  = x(5);% 20
ALFA_R   = x(6);%0.5;
ALFA_PAI = x(7);%1;
ALFA_Y   = x(8);%0.2;
KAPA     = x(9);%3;
GAMAII_GAMAI = x(10);%2;% FIX IT   %0.01;
SSIGMA    = x(11);
ALFA_tau = x(12);
ALFA_tauy= x(13);

RHOG     = x(14);% 0.5;
RHOMUZ   = x(15);% 0.5;
RHOMUUPS = x(16);% 0.5;
RHOPREF  = x(17);% 0.5;
RHOp     = x(18);% 0.5;
RHOw     = x(19);% 0.5;
MUp      = x(20);
MUw      = x(21);

MUZ      = MUZSTAR/ MUUPS^(THETA/(1-THETA));
MUI      = MUUPS * MUZSTAR; 
R        = PAI / BETTA *MUZSTAR; %Nominal interest rate
RK       = (MUI/BETTA -1 + DELTA)/(1-TAU);
MUTIL    = ETATIL / (ETATIL-1)/(1-TAU);
MC       = (ETA - 1)/ETA;% Marginal cost of producing a unit of final good

K_H      = MUI/U*(RK/MC/THETA)^(1/(THETA-1)); % Aggregate capital factor input
IV_H     = (1-(1-DELTA)/MUI) * K_H; % investment
W        = MC * (1-THETA) * (U*K_H/MUI)^THETA; % Average real wage rate
OUTPUT_H = MC*(U*K_H/MUI)^THETA ; % Aggregate absorption
PSSI_H   = (1-MC)*(U*K_H/MUI)^THETA;
G_H      = SHAREG * OUTPUT_H;  % Government spending
C_H      = OUTPUT_H - IV_H - G_H ; % Private consumption

H = 0.5; 
%H        = ((W*PHI*(CTILDE_H/C_H)^(1/MUU)*(1-BETTA*HB/MUZSTAR))/CTILDE_H/MUTIL/(1-HB/MUZSTAR) )^(1/(1+ZZETA));
%ZZETA = -1 + PHI*(C_H/CTILDE_H)^(- 1/MUU)*(1 - BETTA*HB/MUZSTAR)*W/MUTIL *(SSIGMA-1)/CTILDE_H/(1 - HB/MUZSTAR);

OUTPUT   = OUTPUT_H * H;
K        = K_H*H;
PSSI     = PSSI_H*H;
G        = G_H*H;
C        = C_H*H;
%CTILDE = (PHI*(C-C*HB/MUZSTAR)^( (MUU-1)/MUU) + (1-PHI)* (G)^((MUU-1)/MUU))^(MUU/(MUU-1));
CTILDE = (PHI*C^((MUU-1)/MUU)+ (1-PHI)* G^((MUU-1)/MUU))^(MUU/(MUU-1));

IV       = IV_H * H;
%LA       = D*PHI*(CTILDE/C)^(1/MUU)*(1-BETTA*HB/MUZSTAR)*(CTILDE*(1-HB/MUZSTAR)*(1-H^(1+ZZETA)/(1+ZZETA)))^(-SSIGMA);
%LA       = D * PHI*(CTILDE*(1-HB/MUZSTAR))^(-SSIGMA) * H^(ZZETA+1)*(1-HB*BETTA/MUZSTAR); 
%LA       = D * PHI*(C/CTILDE)^(- 1/MUU)*H^(ZZETA + 1)*(CTILDE*(1 - HB/MUZSTAR))^(-SSIGMA) *(1 - BETTA*HB/MUZSTAR);%MUZSTAR^(- SSIGMA))

ZZETA = (C/CTILDE)^(-1/MUU)*PHI*(1 - BETTA*HB/MUZSTAR)*(1-TAU)*W/MUTIL*(1-SSIGMA )*(1-H)/(CTILDE - HB*CTILDE/MUZSTAR);
%ZZETA = (C*(1-HB/MUZSTAR)/CTILDE)^(-1/MUU)*(1 -BETTA*HB/MUZSTAR)*PHI*(1-TAU)*W/MUTIL*(1-SSIGMA )*(1-H)/CTILDE;
%LA   = (C*(1-HB/MUZSTAR)/CTILDE)^(-1/MUU)*D*PHI*(1 - H)^ZZETA/CTILDE^SSIGMA*(1-BETTA*HB/MUZSTAR);
%ZZETA = (C/CTILDE)^(-1/MUU)*PHI*(1 -BETTA*HB/MUZSTAR)*(1-TAU)*W/MUTIL*(1-H)/(CTILDE - (HB*CTILDE)/MUZSTAR);
LA   = (C/CTILDE)^(-1/MUU)*D*PHI*(1 - H)^ZZETA/(CTILDE - HB*CTILDE/MUZSTAR)^SSIGMA*(1 -BETTA*HB/MUZSTAR);
%LA   = (C/CTILDE)^(-1/MUU)*D*PHI*(1 - H)^ZZETA/(CTILDE - HB*CTILDE/MUZSTAR)^SIGMA*(10 -BETTA*HB/MUZSTAR)

GAMAI    = (1-TAU)*RK/QQ;
GAMAII   = GAMAII_GAMAI*GAMAI;
BETTA    = BETTA/MUZSTAR^(1-SSIGMA);

MUC  = MUZSTAR; 
MUIV = MUI;
MUW  = MUZSTAR; 